/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of the License "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description: 
*
*/

package com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CSConfigFactory
 * @model kind="package"
 *        extendedMetaData="qualified='false'"
 * @generated
 */
public interface CSConfigPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "CSConfig";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "platform:/resource/com.nokia.carbide.cpp.codescanner/schema/CSConfig.xsd";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "CSConfig";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	CSConfigPackage eINSTANCE = com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.AccessArrayElementWithoutCheck2TypeImpl <em>Access Array Element Without Check2 Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.AccessArrayElementWithoutCheck2TypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getAccessArrayElementWithoutCheck2Type()
	 * @generated
	 */
	int ACCESS_ARRAY_ELEMENT_WITHOUT_CHECK2_TYPE = 0;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_ARRAY_ELEMENT_WITHOUT_CHECK2_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_ARRAY_ELEMENT_WITHOUT_CHECK2_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_ARRAY_ELEMENT_WITHOUT_CHECK2_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Access Array Element Without Check2 Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_ARRAY_ELEMENT_WITHOUT_CHECK2_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.AccessArrayElementWithoutCheckTypeImpl <em>Access Array Element Without Check Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.AccessArrayElementWithoutCheckTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getAccessArrayElementWithoutCheckType()
	 * @generated
	 */
	int ACCESS_ARRAY_ELEMENT_WITHOUT_CHECK_TYPE = 1;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_ARRAY_ELEMENT_WITHOUT_CHECK_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_ARRAY_ELEMENT_WITHOUT_CHECK_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_ARRAY_ELEMENT_WITHOUT_CHECK_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Access Array Element Without Check Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_ARRAY_ELEMENT_WITHOUT_CHECK_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ActivestartTypeImpl <em>Activestart Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ActivestartTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getActivestartType()
	 * @generated
	 */
	int ACTIVESTART_TYPE = 2;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVESTART_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVESTART_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVESTART_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Activestart Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVESTART_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ActivestopTypeImpl <em>Activestop Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ActivestopTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getActivestopType()
	 * @generated
	 */
	int ACTIVESTOP_TYPE = 3;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVESTOP_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVESTOP_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVESTOP_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Activestop Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVESTOP_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ArgumentsTypeImpl <em>Arguments Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ArgumentsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getArgumentsType()
	 * @generated
	 */
	int ARGUMENTS_TYPE = 4;

	/**
	 * The feature id for the '<em><b>Input</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENTS_TYPE__INPUT = 0;

	/**
	 * The feature id for the '<em><b>Lxr</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENTS_TYPE__LXR = 1;

	/**
	 * The feature id for the '<em><b>Lxrversion</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENTS_TYPE__LXRVERSION = 2;

	/**
	 * The feature id for the '<em><b>Outputformat</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENTS_TYPE__OUTPUTFORMAT = 3;

	/**
	 * The feature id for the '<em><b>Timestampedoutput</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENTS_TYPE__TIMESTAMPEDOUTPUT = 4;

	/**
	 * The number of structural features of the '<em>Arguments Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENTS_TYPE_FEATURE_COUNT = 5;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ArraypassingTypeImpl <em>Arraypassing Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ArraypassingTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getArraypassingType()
	 * @generated
	 */
	int ARRAYPASSING_TYPE = 5;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAYPASSING_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAYPASSING_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAYPASSING_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Arraypassing Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAYPASSING_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ArrayptrcleanupTypeImpl <em>Arrayptrcleanup Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ArrayptrcleanupTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getArrayptrcleanupType()
	 * @generated
	 */
	int ARRAYPTRCLEANUP_TYPE = 6;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAYPTRCLEANUP_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAYPTRCLEANUP_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAYPTRCLEANUP_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Arrayptrcleanup Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAYPTRCLEANUP_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.AssertdebuginvariantTypeImpl <em>Assertdebuginvariant Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.AssertdebuginvariantTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getAssertdebuginvariantType()
	 * @generated
	 */
	int ASSERTDEBUGINVARIANT_TYPE = 7;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERTDEBUGINVARIANT_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERTDEBUGINVARIANT_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERTDEBUGINVARIANT_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Assertdebuginvariant Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERTDEBUGINVARIANT_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.BaddefinesTypeImpl <em>Baddefines Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.BaddefinesTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getBaddefinesType()
	 * @generated
	 */
	int BADDEFINES_TYPE = 8;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BADDEFINES_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BADDEFINES_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BADDEFINES_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Baddefines Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BADDEFINES_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.BaseconstructTypeImpl <em>Baseconstruct Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.BaseconstructTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getBaseconstructType()
	 * @generated
	 */
	int BASECONSTRUCT_TYPE = 9;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASECONSTRUCT_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASECONSTRUCT_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASECONSTRUCT_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Baseconstruct Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASECONSTRUCT_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CallActiveObjectWithoutCheckingOrStoppingTypeImpl <em>Call Active Object Without Checking Or Stopping Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CallActiveObjectWithoutCheckingOrStoppingTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getCallActiveObjectWithoutCheckingOrStoppingType()
	 * @generated
	 */
	int CALL_ACTIVE_OBJECT_WITHOUT_CHECKING_OR_STOPPING_TYPE = 10;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_ACTIVE_OBJECT_WITHOUT_CHECKING_OR_STOPPING_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_ACTIVE_OBJECT_WITHOUT_CHECKING_OR_STOPPING_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_ACTIVE_OBJECT_WITHOUT_CHECKING_OR_STOPPING_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Call Active Object Without Checking Or Stopping Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_ACTIVE_OBJECT_WITHOUT_CHECKING_OR_STOPPING_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CanpanicTypeImpl <em>Canpanic Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CanpanicTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getCanpanicType()
	 * @generated
	 */
	int CANPANIC_TYPE = 11;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CANPANIC_TYPE__ENABLE = 0;

	/**
	 * The number of structural features of the '<em>Canpanic Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CANPANIC_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CategoriesTypeImpl <em>Categories Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CategoriesTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getCategoriesType()
	 * @generated
	 */
	int CATEGORIES_TYPE = 12;

	/**
	 * The feature id for the '<em><b>Canpanic</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORIES_TYPE__CANPANIC = 0;

	/**
	 * The feature id for the '<em><b>Codereview</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORIES_TYPE__CODEREVIEW = 1;

	/**
	 * The feature id for the '<em><b>Codingstandards</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORIES_TYPE__CODINGSTANDARDS = 2;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORIES_TYPE__DOCUMENTATION = 3;

	/**
	 * The feature id for the '<em><b>Functionality</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORIES_TYPE__FUNCTIONALITY = 4;

	/**
	 * The feature id for the '<em><b>Legal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORIES_TYPE__LEGAL = 5;

	/**
	 * The feature id for the '<em><b>Localisation</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORIES_TYPE__LOCALISATION = 6;

	/**
	 * The feature id for the '<em><b>Other</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORIES_TYPE__OTHER = 7;

	/**
	 * The feature id for the '<em><b>Panic</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORIES_TYPE__PANIC = 8;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORIES_TYPE__PERFORMANCE = 9;

	/**
	 * The number of structural features of the '<em>Categories Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CATEGORIES_TYPE_FEATURE_COUNT = 10;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ChangenotificationTypeImpl <em>Changenotification Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ChangenotificationTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getChangenotificationType()
	 * @generated
	 */
	int CHANGENOTIFICATION_TYPE = 13;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CHANGENOTIFICATION_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CHANGENOTIFICATION_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CHANGENOTIFICATION_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Changenotification Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CHANGENOTIFICATION_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CleanupTypeImpl <em>Cleanup Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CleanupTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getCleanupType()
	 * @generated
	 */
	int CLEANUP_TYPE = 14;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLEANUP_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLEANUP_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLEANUP_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Cleanup Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLEANUP_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CodereviewTypeImpl <em>Codereview Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CodereviewTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getCodereviewType()
	 * @generated
	 */
	int CODEREVIEW_TYPE = 15;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODEREVIEW_TYPE__ENABLE = 0;

	/**
	 * The number of structural features of the '<em>Codereview Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODEREVIEW_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CodescannerConfigTypeImpl <em>Codescanner Config Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CodescannerConfigTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getCodescannerConfigType()
	 * @generated
	 */
	int CODESCANNER_CONFIG_TYPE = 16;

	/**
	 * The feature id for the '<em><b>Arguments</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODESCANNER_CONFIG_TYPE__ARGUMENTS = 0;

	/**
	 * The feature id for the '<em><b>Customrules</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODESCANNER_CONFIG_TYPE__CUSTOMRULES = 1;

	/**
	 * The feature id for the '<em><b>Sources</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODESCANNER_CONFIG_TYPE__SOURCES = 2;

	/**
	 * The feature id for the '<em><b>Scripts</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODESCANNER_CONFIG_TYPE__SCRIPTS = 3;

	/**
	 * The feature id for the '<em><b>Severities</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODESCANNER_CONFIG_TYPE__SEVERITIES = 4;

	/**
	 * The feature id for the '<em><b>Categories</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODESCANNER_CONFIG_TYPE__CATEGORIES = 5;

	/**
	 * The number of structural features of the '<em>Codescanner Config Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODESCANNER_CONFIG_TYPE_FEATURE_COUNT = 6;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CodingstandardsTypeImpl <em>Codingstandards Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CodingstandardsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getCodingstandardsType()
	 * @generated
	 */
	int CODINGSTANDARDS_TYPE = 17;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODINGSTANDARDS_TYPE__ENABLE = 0;

	/**
	 * The number of structural features of the '<em>Codingstandards Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODINGSTANDARDS_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CommentcodeTypeImpl <em>Commentcode Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CommentcodeTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getCommentcodeType()
	 * @generated
	 */
	int COMMENTCODE_TYPE = 18;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENTCODE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENTCODE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENTCODE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Commentcode Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENTCODE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ConnectAndDontCloseMemberVariableTypeImpl <em>Connect And Dont Close Member Variable Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ConnectAndDontCloseMemberVariableTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getConnectAndDontCloseMemberVariableType()
	 * @generated
	 */
	int CONNECT_AND_DONT_CLOSE_MEMBER_VARIABLE_TYPE = 19;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECT_AND_DONT_CLOSE_MEMBER_VARIABLE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECT_AND_DONT_CLOSE_MEMBER_VARIABLE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECT_AND_DONT_CLOSE_MEMBER_VARIABLE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Connect And Dont Close Member Variable Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECT_AND_DONT_CLOSE_MEMBER_VARIABLE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ConnectTypeImpl <em>Connect Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ConnectTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getConnectType()
	 * @generated
	 */
	int CONNECT_TYPE = 20;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECT_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECT_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECT_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Connect Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECT_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ConstnamesTypeImpl <em>Constnames Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ConstnamesTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getConstnamesType()
	 * @generated
	 */
	int CONSTNAMES_TYPE = 21;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTNAMES_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTNAMES_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTNAMES_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Constnames Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTNAMES_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ConsttdescptrTypeImpl <em>Consttdescptr Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ConsttdescptrTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getConsttdescptrType()
	 * @generated
	 */
	int CONSTTDESCPTR_TYPE = 22;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTTDESCPTR_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTTDESCPTR_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTTDESCPTR_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Consttdescptr Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTTDESCPTR_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ControlornullTypeImpl <em>Controlornull Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ControlornullTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getControlornullType()
	 * @generated
	 */
	int CONTROLORNULL_TYPE = 23;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROLORNULL_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROLORNULL_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROLORNULL_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Controlornull Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROLORNULL_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CrepositoryTypeImpl <em>Crepository Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CrepositoryTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getCrepositoryType()
	 * @generated
	 */
	int CREPOSITORY_TYPE = 24;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CREPOSITORY_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CREPOSITORY_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CREPOSITORY_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Crepository Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CREPOSITORY_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CtltargettypeTypeImpl <em>Ctltargettype Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CtltargettypeTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getCtltargettypeType()
	 * @generated
	 */
	int CTLTARGETTYPE_TYPE = 25;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CTLTARGETTYPE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CTLTARGETTYPE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CTLTARGETTYPE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Ctltargettype Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CTLTARGETTYPE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CustomizableiconsTypeImpl <em>Customizableicons Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CustomizableiconsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getCustomizableiconsType()
	 * @generated
	 */
	int CUSTOMIZABLEICONS_TYPE = 26;

	/**
	 * The feature id for the '<em><b>Icons RE</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMIZABLEICONS_TYPE__ICONS_RE = 0;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMIZABLEICONS_TYPE__CATEGORY = 1;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMIZABLEICONS_TYPE__ENABLE = 2;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMIZABLEICONS_TYPE__SEVERITY = 3;

	/**
	 * The number of structural features of the '<em>Customizableicons Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMIZABLEICONS_TYPE_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CustomrulesTypeImpl <em>Customrules Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CustomrulesTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getCustomrulesType()
	 * @generated
	 */
	int CUSTOMRULES_TYPE = 27;

	/**
	 * The feature id for the '<em><b>Customrule</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMRULES_TYPE__CUSTOMRULE = 0;

	/**
	 * The number of structural features of the '<em>Customrules Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMRULES_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CustomruleTypeImpl <em>Customrule Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CustomruleTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getCustomruleType()
	 * @generated
	 */
	int CUSTOMRULE_TYPE = 28;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMRULE_TYPE__NAME = 0;

	/**
	 * The feature id for the '<em><b>Keyword</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMRULE_TYPE__KEYWORD = 1;

	/**
	 * The feature id for the '<em><b>Filetype</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMRULE_TYPE__FILETYPE = 2;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMRULE_TYPE__SEVERITY = 3;

	/**
	 * The feature id for the '<em><b>Title</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMRULE_TYPE__TITLE = 4;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMRULE_TYPE__DESCRIPTION = 5;

	/**
	 * The feature id for the '<em><b>Link</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMRULE_TYPE__LINK = 6;

	/**
	 * The number of structural features of the '<em>Customrule Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMRULE_TYPE_FEATURE_COUNT = 7;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DebugromTypeImpl <em>Debugrom Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DebugromTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getDebugromType()
	 * @generated
	 */
	int DEBUGROM_TYPE = 29;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEBUGROM_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEBUGROM_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEBUGROM_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Debugrom Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEBUGROM_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DeclarenameTypeImpl <em>Declarename Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DeclarenameTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getDeclarenameType()
	 * @generated
	 */
	int DECLARENAME_TYPE = 30;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARENAME_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARENAME_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARENAME_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Declarename Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARENAME_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DeleteMemberVariableTypeImpl <em>Delete Member Variable Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DeleteMemberVariableTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getDeleteMemberVariableType()
	 * @generated
	 */
	int DELETE_MEMBER_VARIABLE_TYPE = 31;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELETE_MEMBER_VARIABLE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELETE_MEMBER_VARIABLE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELETE_MEMBER_VARIABLE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Delete Member Variable Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELETE_MEMBER_VARIABLE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DestructorTypeImpl <em>Destructor Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DestructorTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getDestructorType()
	 * @generated
	 */
	int DESTRUCTOR_TYPE = 32;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DESTRUCTOR_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DESTRUCTOR_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DESTRUCTOR_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Destructor Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DESTRUCTOR_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DocumentationTypeImpl <em>Documentation Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DocumentationTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getDocumentationType()
	 * @generated
	 */
	int DOCUMENTATION_TYPE = 33;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENTATION_TYPE__ENABLE = 0;

	/**
	 * The number of structural features of the '<em>Documentation Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENTATION_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DocumentRootImpl <em>Document Root</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DocumentRootImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getDocumentRoot()
	 * @generated
	 */
	int DOCUMENT_ROOT = 34;

	/**
	 * The feature id for the '<em><b>Mixed</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MIXED = 0;

	/**
	 * The feature id for the '<em><b>XMLNS Prefix Map</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__XMLNS_PREFIX_MAP = 1;

	/**
	 * The feature id for the '<em><b>XSI Schema Location</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__XSI_SCHEMA_LOCATION = 2;

	/**
	 * The feature id for the '<em><b>Access Array Element Without Check</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__ACCESS_ARRAY_ELEMENT_WITHOUT_CHECK = 3;

	/**
	 * The feature id for the '<em><b>Access Array Element Without Check2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__ACCESS_ARRAY_ELEMENT_WITHOUT_CHECK2 = 4;

	/**
	 * The feature id for the '<em><b>Activestart</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__ACTIVESTART = 5;

	/**
	 * The feature id for the '<em><b>Activestop</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__ACTIVESTOP = 6;

	/**
	 * The feature id for the '<em><b>Arguments</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__ARGUMENTS = 7;

	/**
	 * The feature id for the '<em><b>Arraypassing</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__ARRAYPASSING = 8;

	/**
	 * The feature id for the '<em><b>Arrayptrcleanup</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__ARRAYPTRCLEANUP = 9;

	/**
	 * The feature id for the '<em><b>Assertdebuginvariant</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__ASSERTDEBUGINVARIANT = 10;

	/**
	 * The feature id for the '<em><b>Baddefines</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__BADDEFINES = 11;

	/**
	 * The feature id for the '<em><b>Baseconstruct</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__BASECONSTRUCT = 12;

	/**
	 * The feature id for the '<em><b>Call Active Object Without Checking Or Stopping</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CALL_ACTIVE_OBJECT_WITHOUT_CHECKING_OR_STOPPING = 13;

	/**
	 * The feature id for the '<em><b>Canpanic</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CANPANIC = 14;

	/**
	 * The feature id for the '<em><b>Categories</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CATEGORIES = 15;

	/**
	 * The feature id for the '<em><b>Cclass Ignore RE</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CCLASS_IGNORE_RE = 16;

	/**
	 * The feature id for the '<em><b>Changenotification</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CHANGENOTIFICATION = 17;

	/**
	 * The feature id for the '<em><b>Cleanup</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CLEANUP = 18;

	/**
	 * The feature id for the '<em><b>Codereview</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CODEREVIEW = 19;

	/**
	 * The feature id for the '<em><b>Codescanner Config</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CODESCANNER_CONFIG = 20;

	/**
	 * The feature id for the '<em><b>Codingstandards</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CODINGSTANDARDS = 21;

	/**
	 * The feature id for the '<em><b>Commentcode</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__COMMENTCODE = 22;

	/**
	 * The feature id for the '<em><b>Connect</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CONNECT = 23;

	/**
	 * The feature id for the '<em><b>Connect And Dont Close Member Variable</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CONNECT_AND_DONT_CLOSE_MEMBER_VARIABLE = 24;

	/**
	 * The feature id for the '<em><b>Constnames</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CONSTNAMES = 25;

	/**
	 * The feature id for the '<em><b>Consttdescptr</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CONSTTDESCPTR = 26;

	/**
	 * The feature id for the '<em><b>Controlornull</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CONTROLORNULL = 27;

	/**
	 * The feature id for the '<em><b>Crepository</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CREPOSITORY = 28;

	/**
	 * The feature id for the '<em><b>Ctltargettype</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CTLTARGETTYPE = 29;

	/**
	 * The feature id for the '<em><b>Customizableicons</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CUSTOMIZABLEICONS = 30;

	/**
	 * The feature id for the '<em><b>Customrule</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CUSTOMRULE = 31;

	/**
	 * The feature id for the '<em><b>Customrules</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CUSTOMRULES = 32;

	/**
	 * The feature id for the '<em><b>Debugrom</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__DEBUGROM = 33;

	/**
	 * The feature id for the '<em><b>Declarename</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__DECLARENAME = 34;

	/**
	 * The feature id for the '<em><b>Delete Member Variable</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__DELETE_MEMBER_VARIABLE = 35;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__DESCRIPTION = 36;

	/**
	 * The feature id for the '<em><b>Destructor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__DESTRUCTOR = 37;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__DOCUMENTATION = 38;

	/**
	 * The feature id for the '<em><b>Double Semi Colon</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__DOUBLE_SEMI_COLON = 39;

	/**
	 * The feature id for the '<em><b>Driveletters</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__DRIVELETTERS = 40;

	/**
	 * The feature id for the '<em><b>Eikbuttons</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__EIKBUTTONS = 41;

	/**
	 * The feature id for the '<em><b>Eikonenvstatic</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__EIKONENVSTATIC = 42;

	/**
	 * The feature id for the '<em><b>Enummembers</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__ENUMMEMBERS = 43;

	/**
	 * The feature id for the '<em><b>Enumnames</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__ENUMNAMES = 44;

	/**
	 * The feature id for the '<em><b>Exclude</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__EXCLUDE = 45;

	/**
	 * The feature id for the '<em><b>Exportinline</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__EXPORTINLINE = 46;

	/**
	 * The feature id for the '<em><b>Exportpurevirtual</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__EXPORTPUREVIRTUAL = 47;

	/**
	 * The feature id for the '<em><b>Externaldriveletters</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__EXTERNALDRIVELETTERS = 48;

	/**
	 * The feature id for the '<em><b>Filetype</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__FILETYPE = 49;

	/**
	 * The feature id for the '<em><b>Flags</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__FLAGS = 50;

	/**
	 * The feature id for the '<em><b>Foff</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__FOFF = 51;

	/**
	 * The feature id for the '<em><b>Forbiddenwords</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__FORBIDDENWORDS = 52;

	/**
	 * The feature id for the '<em><b>Forgottoputptroncleanupstack</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__FORGOTTOPUTPTRONCLEANUPSTACK = 53;

	/**
	 * The feature id for the '<em><b>Friend</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__FRIEND = 54;

	/**
	 * The feature id for the '<em><b>Functionality</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__FUNCTIONALITY = 55;

	/**
	 * The feature id for the '<em><b>Goto</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__GOTO = 56;

	/**
	 * The feature id for the '<em><b>High</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__HIGH = 57;

	/**
	 * The feature id for the '<em><b>Icons RE</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__ICONS_RE = 58;

	/**
	 * The feature id for the '<em><b>Ifassignments</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__IFASSIGNMENTS = 59;

	/**
	 * The feature id for the '<em><b>Ifpreprocessor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__IFPREPROCESSOR = 60;

	/**
	 * The feature id for the '<em><b>Inheritanceorder</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__INHERITANCEORDER = 61;

	/**
	 * The feature id for the '<em><b>Input</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__INPUT = 62;

	/**
	 * The feature id for the '<em><b>Intleaves</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__INTLEAVES = 63;

	/**
	 * The feature id for the '<em><b>Jmp</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__JMP = 64;

	/**
	 * The feature id for the '<em><b>Keyword</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__KEYWORD = 65;

	/**
	 * The feature id for the '<em><b>Leave</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__LEAVE = 66;

	/**
	 * The feature id for the '<em><b>Leave No Error</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__LEAVE_NO_ERROR = 67;

	/**
	 * The feature id for the '<em><b>Leavingoperators</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__LEAVINGOPERATORS = 68;

	/**
	 * The feature id for the '<em><b>Legal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__LEGAL = 69;

	/**
	 * The feature id for the '<em><b>LFunction Cant Leave</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__LFUNCTION_CANT_LEAVE = 70;

	/**
	 * The feature id for the '<em><b>LFunction Ignore RE</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__LFUNCTION_IGNORE_RE = 71;

	/**
	 * The feature id for the '<em><b>Link</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__LINK = 72;

	/**
	 * The feature id for the '<em><b>Localisation</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__LOCALISATION = 73;

	/**
	 * The feature id for the '<em><b>Longlines</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__LONGLINES = 74;

	/**
	 * The feature id for the '<em><b>Low</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__LOW = 75;

	/**
	 * The feature id for the '<em><b>Lxr</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__LXR = 76;

	/**
	 * The feature id for the '<em><b>Lxrversion</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__LXRVERSION = 77;

	/**
	 * The feature id for the '<em><b>Magicnumbers</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MAGICNUMBERS = 78;

	/**
	 * The feature id for the '<em><b>Mclassdestructor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MCLASSDESTRUCTOR = 79;

	/**
	 * The feature id for the '<em><b>Medium</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MEDIUM = 80;

	/**
	 * The feature id for the '<em><b>Memberlc</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MEMBERLC = 81;

	/**
	 * The feature id for the '<em><b>Membervariablecallld</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MEMBERVARIABLECALLLD = 82;

	/**
	 * The feature id for the '<em><b>Missingcancel</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MISSINGCANCEL = 83;

	/**
	 * The feature id for the '<em><b>Missingcclass</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MISSINGCCLASS = 84;

	/**
	 * The feature id for the '<em><b>Mmpsourcepath</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MMPSOURCEPATH = 85;

	/**
	 * The feature id for the '<em><b>Multilangrsc</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MULTILANGRSC = 86;

	/**
	 * The feature id for the '<em><b>Multipledeclarations</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MULTIPLEDECLARATIONS = 87;

	/**
	 * The feature id for the '<em><b>Multipleinheritance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MULTIPLEINHERITANCE = 88;

	/**
	 * The feature id for the '<em><b>Mydocs</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MYDOCS = 89;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__NAME = 90;

	/**
	 * The feature id for the '<em><b>Namespace</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__NAMESPACE = 91;

	/**
	 * The feature id for the '<em><b>Newlreferences</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__NEWLREFERENCES = 92;

	/**
	 * The feature id for the '<em><b>Noleavetrap</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__NOLEAVETRAP = 93;

	/**
	 * The feature id for the '<em><b>Nonconsthbufc</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__NONCONSTHBUFC = 94;

	/**
	 * The feature id for the '<em><b>Nonconsttdesc</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__NONCONSTTDESC = 95;

	/**
	 * The feature id for the '<em><b>Nonleavenew</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__NONLEAVENEW = 96;

	/**
	 * The feature id for the '<em><b>Nonunicodeskins</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__NONUNICODESKINS = 97;

	/**
	 * The feature id for the '<em><b>Null</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__NULL = 98;

	/**
	 * The feature id for the '<em><b>Open</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__OPEN = 99;

	/**
	 * The feature id for the '<em><b>Open Ignore RE</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__OPEN_IGNORE_RE = 100;

	/**
	 * The feature id for the '<em><b>Other</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__OTHER = 101;

	/**
	 * The feature id for the '<em><b>Outputformat</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__OUTPUTFORMAT = 102;

	/**
	 * The feature id for the '<em><b>Panic</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__PANIC = 103;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__PERFORMANCE = 104;

	/**
	 * The feature id for the '<em><b>Pointertoarrays</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__POINTERTOARRAYS = 105;

	/**
	 * The feature id for the '<em><b>Pragmadisable</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__PRAGMADISABLE = 106;

	/**
	 * The feature id for the '<em><b>Pragmamessage</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__PRAGMAMESSAGE = 107;

	/**
	 * The feature id for the '<em><b>Pragmaother</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__PRAGMAOTHER = 108;

	/**
	 * The feature id for the '<em><b>Privateinheritance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__PRIVATEINHERITANCE = 109;

	/**
	 * The feature id for the '<em><b>Pushaddrvar</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__PUSHADDRVAR = 110;

	/**
	 * The feature id for the '<em><b>Pushmember</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__PUSHMEMBER = 111;

	/**
	 * The feature id for the '<em><b>Readresource</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__READRESOURCE = 112;

	/**
	 * The feature id for the '<em><b>Resourcenotoncleanupstack</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__RESOURCENOTONCLEANUPSTACK = 113;

	/**
	 * The feature id for the '<em><b>Resourcesonheap</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__RESOURCESONHEAP = 114;

	/**
	 * The feature id for the '<em><b>Returndescriptoroutofscope</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__RETURNDESCRIPTOROUTOFSCOPE = 115;

	/**
	 * The feature id for the '<em><b>Rfs</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__RFS = 116;

	/**
	 * The feature id for the '<em><b>Rssnames</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__RSSNAMES = 117;

	/**
	 * The feature id for the '<em><b>Scripts</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__SCRIPTS = 118;

	/**
	 * The feature id for the '<em><b>Severities</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__SEVERITIES = 119;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__SEVERITY = 120;

	/**
	 * The feature id for the '<em><b>Sources</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__SOURCES = 121;

	/**
	 * The feature id for the '<em><b>Stringliterals</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__STRINGLITERALS = 122;

	/**
	 * The feature id for the '<em><b>Stringsinresourcefiles</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__STRINGSINRESOURCEFILES = 123;

	/**
	 * The feature id for the '<em><b>Struct</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__STRUCT = 124;

	/**
	 * The feature id for the '<em><b>Tcclasses</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__TCCLASSES = 125;

	/**
	 * The feature id for the '<em><b>Tclassdestructor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__TCLASSDESTRUCTOR = 126;

	/**
	 * The feature id for the '<em><b>Timestampedoutput</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__TIMESTAMPEDOUTPUT = 127;

	/**
	 * The feature id for the '<em><b>Title</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__TITLE = 128;

	/**
	 * The feature id for the '<em><b>Todocomments</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__TODOCOMMENTS = 129;

	/**
	 * The feature id for the '<em><b>Trapcleanup</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__TRAPCLEANUP = 130;

	/**
	 * The feature id for the '<em><b>Trapeleave</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__TRAPELEAVE = 131;

	/**
	 * The feature id for the '<em><b>Traprunl</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__TRAPRUNL = 132;

	/**
	 * The feature id for the '<em><b>Trspassing</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__TRSPASSING = 133;

	/**
	 * The feature id for the '<em><b>Uids</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__UIDS = 134;

	/**
	 * The feature id for the '<em><b>Uncompressedaif</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__UNCOMPRESSEDAIF = 135;

	/**
	 * The feature id for the '<em><b>Uncompressedbmp</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__UNCOMPRESSEDBMP = 136;

	/**
	 * The feature id for the '<em><b>Unicodesource</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__UNICODESOURCE = 137;

	/**
	 * The feature id for the '<em><b>Userafter</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__USERAFTER = 138;

	/**
	 * The feature id for the '<em><b>Userfree</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__USERFREE = 139;

	/**
	 * The feature id for the '<em><b>User Wait For Request</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__USER_WAIT_FOR_REQUEST = 140;

	/**
	 * The feature id for the '<em><b>Variablenames</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__VARIABLENAMES = 141;

	/**
	 * The feature id for the '<em><b>Voidparameter</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__VOIDPARAMETER = 142;

	/**
	 * The feature id for the '<em><b>Words RE</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__WORDS_RE = 143;

	/**
	 * The feature id for the '<em><b>Worryingcomments</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__WORRYINGCOMMENTS = 144;

	/**
	 * The feature id for the '<em><b>Worry RE</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__WORRY_RE = 145;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CATEGORY = 146;

	/**
	 * The feature id for the '<em><b>Severity1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__SEVERITY1 = 147;

	/**
	 * The number of structural features of the '<em>Document Root</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT_FEATURE_COUNT = 148;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DoubleSemiColonTypeImpl <em>Double Semi Colon Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DoubleSemiColonTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getDoubleSemiColonType()
	 * @generated
	 */
	int DOUBLE_SEMI_COLON_TYPE = 35;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOUBLE_SEMI_COLON_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOUBLE_SEMI_COLON_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOUBLE_SEMI_COLON_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Double Semi Colon Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOUBLE_SEMI_COLON_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DrivelettersTypeImpl <em>Driveletters Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.DrivelettersTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getDrivelettersType()
	 * @generated
	 */
	int DRIVELETTERS_TYPE = 36;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIVELETTERS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIVELETTERS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIVELETTERS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Driveletters Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIVELETTERS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.EikbuttonsTypeImpl <em>Eikbuttons Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.EikbuttonsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getEikbuttonsType()
	 * @generated
	 */
	int EIKBUTTONS_TYPE = 37;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EIKBUTTONS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EIKBUTTONS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EIKBUTTONS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Eikbuttons Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EIKBUTTONS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.EikonenvstaticTypeImpl <em>Eikonenvstatic Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.EikonenvstaticTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getEikonenvstaticType()
	 * @generated
	 */
	int EIKONENVSTATIC_TYPE = 38;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EIKONENVSTATIC_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EIKONENVSTATIC_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EIKONENVSTATIC_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Eikonenvstatic Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EIKONENVSTATIC_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.EnummembersTypeImpl <em>Enummembers Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.EnummembersTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getEnummembersType()
	 * @generated
	 */
	int ENUMMEMBERS_TYPE = 39;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMMEMBERS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMMEMBERS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMMEMBERS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Enummembers Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMMEMBERS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.EnumnamesTypeImpl <em>Enumnames Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.EnumnamesTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getEnumnamesType()
	 * @generated
	 */
	int ENUMNAMES_TYPE = 40;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMNAMES_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMNAMES_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMNAMES_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Enumnames Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMNAMES_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ExportinlineTypeImpl <em>Exportinline Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ExportinlineTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getExportinlineType()
	 * @generated
	 */
	int EXPORTINLINE_TYPE = 41;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPORTINLINE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPORTINLINE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPORTINLINE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Exportinline Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPORTINLINE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ExportpurevirtualTypeImpl <em>Exportpurevirtual Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ExportpurevirtualTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getExportpurevirtualType()
	 * @generated
	 */
	int EXPORTPUREVIRTUAL_TYPE = 42;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPORTPUREVIRTUAL_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPORTPUREVIRTUAL_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPORTPUREVIRTUAL_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Exportpurevirtual Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPORTPUREVIRTUAL_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ExternaldrivelettersTypeImpl <em>Externaldriveletters Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ExternaldrivelettersTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getExternaldrivelettersType()
	 * @generated
	 */
	int EXTERNALDRIVELETTERS_TYPE = 43;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNALDRIVELETTERS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNALDRIVELETTERS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNALDRIVELETTERS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Externaldriveletters Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNALDRIVELETTERS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.FlagsTypeImpl <em>Flags Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.FlagsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getFlagsType()
	 * @generated
	 */
	int FLAGS_TYPE = 44;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLAGS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLAGS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLAGS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Flags Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLAGS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.FoffTypeImpl <em>Foff Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.FoffTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getFoffType()
	 * @generated
	 */
	int FOFF_TYPE = 45;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOFF_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOFF_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOFF_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Foff Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOFF_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ForbiddenwordsTypeImpl <em>Forbiddenwords Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ForbiddenwordsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getForbiddenwordsType()
	 * @generated
	 */
	int FORBIDDENWORDS_TYPE = 46;

	/**
	 * The feature id for the '<em><b>Words RE</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORBIDDENWORDS_TYPE__WORDS_RE = 0;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORBIDDENWORDS_TYPE__CATEGORY = 1;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORBIDDENWORDS_TYPE__ENABLE = 2;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORBIDDENWORDS_TYPE__SEVERITY = 3;

	/**
	 * The number of structural features of the '<em>Forbiddenwords Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORBIDDENWORDS_TYPE_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ForgottoputptroncleanupstackTypeImpl <em>Forgottoputptroncleanupstack Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ForgottoputptroncleanupstackTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getForgottoputptroncleanupstackType()
	 * @generated
	 */
	int FORGOTTOPUTPTRONCLEANUPSTACK_TYPE = 47;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORGOTTOPUTPTRONCLEANUPSTACK_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORGOTTOPUTPTRONCLEANUPSTACK_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORGOTTOPUTPTRONCLEANUPSTACK_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Forgottoputptroncleanupstack Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORGOTTOPUTPTRONCLEANUPSTACK_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.FriendTypeImpl <em>Friend Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.FriendTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getFriendType()
	 * @generated
	 */
	int FRIEND_TYPE = 48;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRIEND_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRIEND_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRIEND_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Friend Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRIEND_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.FunctionalityTypeImpl <em>Functionality Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.FunctionalityTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getFunctionalityType()
	 * @generated
	 */
	int FUNCTIONALITY_TYPE = 49;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTIONALITY_TYPE__ENABLE = 0;

	/**
	 * The number of structural features of the '<em>Functionality Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTIONALITY_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.GotoTypeImpl <em>Goto Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.GotoTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getGotoType()
	 * @generated
	 */
	int GOTO_TYPE = 50;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOTO_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOTO_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOTO_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Goto Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOTO_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.HighTypeImpl <em>High Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.HighTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getHighType()
	 * @generated
	 */
	int HIGH_TYPE = 51;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HIGH_TYPE__ENABLE = 0;

	/**
	 * The number of structural features of the '<em>High Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HIGH_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.IfassignmentsTypeImpl <em>Ifassignments Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.IfassignmentsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getIfassignmentsType()
	 * @generated
	 */
	int IFASSIGNMENTS_TYPE = 52;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IFASSIGNMENTS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IFASSIGNMENTS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IFASSIGNMENTS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Ifassignments Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IFASSIGNMENTS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.IfpreprocessorTypeImpl <em>Ifpreprocessor Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.IfpreprocessorTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getIfpreprocessorType()
	 * @generated
	 */
	int IFPREPROCESSOR_TYPE = 53;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IFPREPROCESSOR_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IFPREPROCESSOR_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IFPREPROCESSOR_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Ifpreprocessor Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IFPREPROCESSOR_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.InheritanceorderTypeImpl <em>Inheritanceorder Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.InheritanceorderTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getInheritanceorderType()
	 * @generated
	 */
	int INHERITANCEORDER_TYPE = 54;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INHERITANCEORDER_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INHERITANCEORDER_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INHERITANCEORDER_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Inheritanceorder Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INHERITANCEORDER_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.IntleavesTypeImpl <em>Intleaves Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.IntleavesTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getIntleavesType()
	 * @generated
	 */
	int INTLEAVES_TYPE = 55;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTLEAVES_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTLEAVES_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTLEAVES_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Intleaves Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTLEAVES_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.JmpTypeImpl <em>Jmp Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.JmpTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getJmpType()
	 * @generated
	 */
	int JMP_TYPE = 56;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JMP_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JMP_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JMP_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Jmp Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JMP_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.KeywordTypeImpl <em>Keyword Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.KeywordTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getKeywordType()
	 * @generated
	 */
	int KEYWORD_TYPE = 57;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KEYWORD_TYPE__VALUE = 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KEYWORD_TYPE__TYPE = 1;

	/**
	 * The number of structural features of the '<em>Keyword Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KEYWORD_TYPE_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LeaveNoErrorTypeImpl <em>Leave No Error Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LeaveNoErrorTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getLeaveNoErrorType()
	 * @generated
	 */
	int LEAVE_NO_ERROR_TYPE = 58;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LEAVE_NO_ERROR_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LEAVE_NO_ERROR_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LEAVE_NO_ERROR_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Leave No Error Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LEAVE_NO_ERROR_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LeaveTypeImpl <em>Leave Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LeaveTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getLeaveType()
	 * @generated
	 */
	int LEAVE_TYPE = 59;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LEAVE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LEAVE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LEAVE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Leave Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LEAVE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LeavingoperatorsTypeImpl <em>Leavingoperators Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LeavingoperatorsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getLeavingoperatorsType()
	 * @generated
	 */
	int LEAVINGOPERATORS_TYPE = 60;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LEAVINGOPERATORS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LEAVINGOPERATORS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LEAVINGOPERATORS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Leavingoperators Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LEAVINGOPERATORS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LegalTypeImpl <em>Legal Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LegalTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getLegalType()
	 * @generated
	 */
	int LEGAL_TYPE = 61;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LEGAL_TYPE__ENABLE = 0;

	/**
	 * The number of structural features of the '<em>Legal Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LEGAL_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LFunctionCantLeaveTypeImpl <em>LFunction Cant Leave Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LFunctionCantLeaveTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getLFunctionCantLeaveType()
	 * @generated
	 */
	int LFUNCTION_CANT_LEAVE_TYPE = 62;

	/**
	 * The feature id for the '<em><b>LFunction Ignore RE</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LFUNCTION_CANT_LEAVE_TYPE__LFUNCTION_IGNORE_RE = 0;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LFUNCTION_CANT_LEAVE_TYPE__CATEGORY = 1;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LFUNCTION_CANT_LEAVE_TYPE__ENABLE = 2;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LFUNCTION_CANT_LEAVE_TYPE__SEVERITY = 3;

	/**
	 * The number of structural features of the '<em>LFunction Cant Leave Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LFUNCTION_CANT_LEAVE_TYPE_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LocalisationTypeImpl <em>Localisation Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LocalisationTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getLocalisationType()
	 * @generated
	 */
	int LOCALISATION_TYPE = 63;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCALISATION_TYPE__ENABLE = 0;

	/**
	 * The number of structural features of the '<em>Localisation Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCALISATION_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LonglinesTypeImpl <em>Longlines Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LonglinesTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getLonglinesType()
	 * @generated
	 */
	int LONGLINES_TYPE = 64;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LONGLINES_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LONGLINES_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LONGLINES_TYPE__LENGTH = 2;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LONGLINES_TYPE__SEVERITY = 3;

	/**
	 * The number of structural features of the '<em>Longlines Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LONGLINES_TYPE_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LowTypeImpl <em>Low Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.LowTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getLowType()
	 * @generated
	 */
	int LOW_TYPE = 65;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOW_TYPE__ENABLE = 0;

	/**
	 * The number of structural features of the '<em>Low Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOW_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MagicnumbersTypeImpl <em>Magicnumbers Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MagicnumbersTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getMagicnumbersType()
	 * @generated
	 */
	int MAGICNUMBERS_TYPE = 66;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAGICNUMBERS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAGICNUMBERS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAGICNUMBERS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Magicnumbers Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAGICNUMBERS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MclassdestructorTypeImpl <em>Mclassdestructor Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MclassdestructorTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getMclassdestructorType()
	 * @generated
	 */
	int MCLASSDESTRUCTOR_TYPE = 67;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSDESTRUCTOR_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSDESTRUCTOR_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSDESTRUCTOR_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Mclassdestructor Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MCLASSDESTRUCTOR_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MediumTypeImpl <em>Medium Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MediumTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getMediumType()
	 * @generated
	 */
	int MEDIUM_TYPE = 68;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIUM_TYPE__ENABLE = 0;

	/**
	 * The number of structural features of the '<em>Medium Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIUM_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MemberlcTypeImpl <em>Memberlc Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MemberlcTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getMemberlcType()
	 * @generated
	 */
	int MEMBERLC_TYPE = 69;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBERLC_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBERLC_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBERLC_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Memberlc Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBERLC_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MembervariablecallldTypeImpl <em>Membervariablecallld Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MembervariablecallldTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getMembervariablecallldType()
	 * @generated
	 */
	int MEMBERVARIABLECALLLD_TYPE = 70;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBERVARIABLECALLLD_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBERVARIABLECALLLD_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBERVARIABLECALLLD_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Membervariablecallld Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMBERVARIABLECALLLD_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MissingcancelTypeImpl <em>Missingcancel Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MissingcancelTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getMissingcancelType()
	 * @generated
	 */
	int MISSINGCANCEL_TYPE = 71;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MISSINGCANCEL_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MISSINGCANCEL_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MISSINGCANCEL_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Missingcancel Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MISSINGCANCEL_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MissingcclassTypeImpl <em>Missingcclass Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MissingcclassTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getMissingcclassType()
	 * @generated
	 */
	int MISSINGCCLASS_TYPE = 72;

	/**
	 * The feature id for the '<em><b>Cclass Ignore RE</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MISSINGCCLASS_TYPE__CCLASS_IGNORE_RE = 0;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MISSINGCCLASS_TYPE__CATEGORY = 1;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MISSINGCCLASS_TYPE__ENABLE = 2;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MISSINGCCLASS_TYPE__SEVERITY = 3;

	/**
	 * The number of structural features of the '<em>Missingcclass Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MISSINGCCLASS_TYPE_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MmpsourcepathTypeImpl <em>Mmpsourcepath Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MmpsourcepathTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getMmpsourcepathType()
	 * @generated
	 */
	int MMPSOURCEPATH_TYPE = 73;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMPSOURCEPATH_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMPSOURCEPATH_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMPSOURCEPATH_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Mmpsourcepath Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MMPSOURCEPATH_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MultilangrscTypeImpl <em>Multilangrsc Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MultilangrscTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getMultilangrscType()
	 * @generated
	 */
	int MULTILANGRSC_TYPE = 74;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTILANGRSC_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTILANGRSC_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTILANGRSC_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Multilangrsc Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTILANGRSC_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MultipledeclarationsTypeImpl <em>Multipledeclarations Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MultipledeclarationsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getMultipledeclarationsType()
	 * @generated
	 */
	int MULTIPLEDECLARATIONS_TYPE = 75;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTIPLEDECLARATIONS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTIPLEDECLARATIONS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTIPLEDECLARATIONS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Multipledeclarations Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTIPLEDECLARATIONS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MultipleinheritanceTypeImpl <em>Multipleinheritance Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MultipleinheritanceTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getMultipleinheritanceType()
	 * @generated
	 */
	int MULTIPLEINHERITANCE_TYPE = 76;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTIPLEINHERITANCE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTIPLEINHERITANCE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTIPLEINHERITANCE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Multipleinheritance Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULTIPLEINHERITANCE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MydocsTypeImpl <em>Mydocs Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.MydocsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getMydocsType()
	 * @generated
	 */
	int MYDOCS_TYPE = 77;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MYDOCS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MYDOCS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MYDOCS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Mydocs Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MYDOCS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NamespaceTypeImpl <em>Namespace Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NamespaceTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getNamespaceType()
	 * @generated
	 */
	int NAMESPACE_TYPE = 78;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMESPACE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMESPACE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMESPACE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Namespace Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMESPACE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NewlreferencesTypeImpl <em>Newlreferences Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NewlreferencesTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getNewlreferencesType()
	 * @generated
	 */
	int NEWLREFERENCES_TYPE = 79;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEWLREFERENCES_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEWLREFERENCES_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEWLREFERENCES_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Newlreferences Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEWLREFERENCES_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NoleavetrapTypeImpl <em>Noleavetrap Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NoleavetrapTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getNoleavetrapType()
	 * @generated
	 */
	int NOLEAVETRAP_TYPE = 80;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOLEAVETRAP_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOLEAVETRAP_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOLEAVETRAP_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Noleavetrap Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOLEAVETRAP_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NonconsthbufcTypeImpl <em>Nonconsthbufc Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NonconsthbufcTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getNonconsthbufcType()
	 * @generated
	 */
	int NONCONSTHBUFC_TYPE = 81;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONCONSTHBUFC_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONCONSTHBUFC_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONCONSTHBUFC_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Nonconsthbufc Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONCONSTHBUFC_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NonconsttdescTypeImpl <em>Nonconsttdesc Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NonconsttdescTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getNonconsttdescType()
	 * @generated
	 */
	int NONCONSTTDESC_TYPE = 82;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONCONSTTDESC_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONCONSTTDESC_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONCONSTTDESC_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Nonconsttdesc Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONCONSTTDESC_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NonleavenewTypeImpl <em>Nonleavenew Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NonleavenewTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getNonleavenewType()
	 * @generated
	 */
	int NONLEAVENEW_TYPE = 83;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONLEAVENEW_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONLEAVENEW_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONLEAVENEW_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Nonleavenew Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONLEAVENEW_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NonunicodeskinsTypeImpl <em>Nonunicodeskins Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NonunicodeskinsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getNonunicodeskinsType()
	 * @generated
	 */
	int NONUNICODESKINS_TYPE = 84;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONUNICODESKINS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONUNICODESKINS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONUNICODESKINS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Nonunicodeskins Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NONUNICODESKINS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NullTypeImpl <em>Null Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.NullTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getNullType()
	 * @generated
	 */
	int NULL_TYPE = 85;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULL_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULL_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULL_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Null Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULL_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.OpenTypeImpl <em>Open Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.OpenTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getOpenType()
	 * @generated
	 */
	int OPEN_TYPE = 86;

	/**
	 * The feature id for the '<em><b>Open Ignore RE</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPEN_TYPE__OPEN_IGNORE_RE = 0;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPEN_TYPE__CATEGORY = 1;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPEN_TYPE__ENABLE = 2;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPEN_TYPE__SEVERITY = 3;

	/**
	 * The number of structural features of the '<em>Open Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPEN_TYPE_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.OtherTypeImpl <em>Other Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.OtherTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getOtherType()
	 * @generated
	 */
	int OTHER_TYPE = 87;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OTHER_TYPE__ENABLE = 0;

	/**
	 * The number of structural features of the '<em>Other Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OTHER_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PanicTypeImpl <em>Panic Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PanicTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getPanicType()
	 * @generated
	 */
	int PANIC_TYPE = 88;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PANIC_TYPE__ENABLE = 0;

	/**
	 * The number of structural features of the '<em>Panic Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PANIC_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PerformanceTypeImpl <em>Performance Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PerformanceTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getPerformanceType()
	 * @generated
	 */
	int PERFORMANCE_TYPE = 89;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_TYPE__ENABLE = 0;

	/**
	 * The number of structural features of the '<em>Performance Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PointertoarraysTypeImpl <em>Pointertoarrays Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PointertoarraysTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getPointertoarraysType()
	 * @generated
	 */
	int POINTERTOARRAYS_TYPE = 90;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POINTERTOARRAYS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POINTERTOARRAYS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POINTERTOARRAYS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Pointertoarrays Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POINTERTOARRAYS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PragmadisableTypeImpl <em>Pragmadisable Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PragmadisableTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getPragmadisableType()
	 * @generated
	 */
	int PRAGMADISABLE_TYPE = 91;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMADISABLE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMADISABLE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMADISABLE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Pragmadisable Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMADISABLE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PragmamessageTypeImpl <em>Pragmamessage Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PragmamessageTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getPragmamessageType()
	 * @generated
	 */
	int PRAGMAMESSAGE_TYPE = 92;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMAMESSAGE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMAMESSAGE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMAMESSAGE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Pragmamessage Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMAMESSAGE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PragmaotherTypeImpl <em>Pragmaother Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PragmaotherTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getPragmaotherType()
	 * @generated
	 */
	int PRAGMAOTHER_TYPE = 93;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMAOTHER_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMAOTHER_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMAOTHER_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Pragmaother Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMAOTHER_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PrivateinheritanceTypeImpl <em>Privateinheritance Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PrivateinheritanceTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getPrivateinheritanceType()
	 * @generated
	 */
	int PRIVATEINHERITANCE_TYPE = 94;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATEINHERITANCE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATEINHERITANCE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATEINHERITANCE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Privateinheritance Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATEINHERITANCE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PushaddrvarTypeImpl <em>Pushaddrvar Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PushaddrvarTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getPushaddrvarType()
	 * @generated
	 */
	int PUSHADDRVAR_TYPE = 95;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUSHADDRVAR_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUSHADDRVAR_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUSHADDRVAR_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Pushaddrvar Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUSHADDRVAR_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PushmemberTypeImpl <em>Pushmember Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.PushmemberTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getPushmemberType()
	 * @generated
	 */
	int PUSHMEMBER_TYPE = 96;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUSHMEMBER_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUSHMEMBER_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUSHMEMBER_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Pushmember Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PUSHMEMBER_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ReadresourceTypeImpl <em>Readresource Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ReadresourceTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getReadresourceType()
	 * @generated
	 */
	int READRESOURCE_TYPE = 97;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READRESOURCE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READRESOURCE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READRESOURCE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Readresource Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READRESOURCE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ResourcenotoncleanupstackTypeImpl <em>Resourcenotoncleanupstack Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ResourcenotoncleanupstackTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getResourcenotoncleanupstackType()
	 * @generated
	 */
	int RESOURCENOTONCLEANUPSTACK_TYPE = 98;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCENOTONCLEANUPSTACK_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCENOTONCLEANUPSTACK_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCENOTONCLEANUPSTACK_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Resourcenotoncleanupstack Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCENOTONCLEANUPSTACK_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ResourcesonheapTypeImpl <em>Resourcesonheap Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ResourcesonheapTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getResourcesonheapType()
	 * @generated
	 */
	int RESOURCESONHEAP_TYPE = 99;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCESONHEAP_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCESONHEAP_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCESONHEAP_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Resourcesonheap Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCESONHEAP_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ReturndescriptoroutofscopeTypeImpl <em>Returndescriptoroutofscope Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ReturndescriptoroutofscopeTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getReturndescriptoroutofscopeType()
	 * @generated
	 */
	int RETURNDESCRIPTOROUTOFSCOPE_TYPE = 100;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETURNDESCRIPTOROUTOFSCOPE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETURNDESCRIPTOROUTOFSCOPE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETURNDESCRIPTOROUTOFSCOPE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Returndescriptoroutofscope Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RETURNDESCRIPTOROUTOFSCOPE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.RfsTypeImpl <em>Rfs Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.RfsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getRfsType()
	 * @generated
	 */
	int RFS_TYPE = 101;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Rfs Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.RssnamesTypeImpl <em>Rssnames Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.RssnamesTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getRssnamesType()
	 * @generated
	 */
	int RSSNAMES_TYPE = 102;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RSSNAMES_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RSSNAMES_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RSSNAMES_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Rssnames Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RSSNAMES_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ScriptsTypeImpl <em>Scripts Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.ScriptsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getScriptsType()
	 * @generated
	 */
	int SCRIPTS_TYPE = 103;

	/**
	 * The feature id for the '<em><b>Mixed</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__MIXED = 0;

	/**
	 * The feature id for the '<em><b>Access Array Element Without Check</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__ACCESS_ARRAY_ELEMENT_WITHOUT_CHECK = 1;

	/**
	 * The feature id for the '<em><b>Access Array Element Without Check2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__ACCESS_ARRAY_ELEMENT_WITHOUT_CHECK2 = 2;

	/**
	 * The feature id for the '<em><b>Activestart</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__ACTIVESTART = 3;

	/**
	 * The feature id for the '<em><b>Activestop</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__ACTIVESTOP = 4;

	/**
	 * The feature id for the '<em><b>Arraypassing</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__ARRAYPASSING = 5;

	/**
	 * The feature id for the '<em><b>Arrayptrcleanup</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__ARRAYPTRCLEANUP = 6;

	/**
	 * The feature id for the '<em><b>Assertdebuginvariant</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__ASSERTDEBUGINVARIANT = 7;

	/**
	 * The feature id for the '<em><b>Baddefines</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__BADDEFINES = 8;

	/**
	 * The feature id for the '<em><b>Baseconstruct</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__BASECONSTRUCT = 9;

	/**
	 * The feature id for the '<em><b>Call Active Object Without Checking Or Stopping</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__CALL_ACTIVE_OBJECT_WITHOUT_CHECKING_OR_STOPPING = 10;

	/**
	 * The feature id for the '<em><b>Changenotification</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__CHANGENOTIFICATION = 11;

	/**
	 * The feature id for the '<em><b>Cleanup</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__CLEANUP = 12;

	/**
	 * The feature id for the '<em><b>Commentcode</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__COMMENTCODE = 13;

	/**
	 * The feature id for the '<em><b>Connect</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__CONNECT = 14;

	/**
	 * The feature id for the '<em><b>Connect And Dont Close Member Variable</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__CONNECT_AND_DONT_CLOSE_MEMBER_VARIABLE = 15;

	/**
	 * The feature id for the '<em><b>Constnames</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__CONSTNAMES = 16;

	/**
	 * The feature id for the '<em><b>Consttdescptr</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__CONSTTDESCPTR = 17;

	/**
	 * The feature id for the '<em><b>Controlornull</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__CONTROLORNULL = 18;

	/**
	 * The feature id for the '<em><b>Crepository</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__CREPOSITORY = 19;

	/**
	 * The feature id for the '<em><b>Ctltargettype</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__CTLTARGETTYPE = 20;

	/**
	 * The feature id for the '<em><b>Customizableicons</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__CUSTOMIZABLEICONS = 21;

	/**
	 * The feature id for the '<em><b>Debugrom</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__DEBUGROM = 22;

	/**
	 * The feature id for the '<em><b>Declarename</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__DECLARENAME = 23;

	/**
	 * The feature id for the '<em><b>Delete Member Variable</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__DELETE_MEMBER_VARIABLE = 24;

	/**
	 * The feature id for the '<em><b>Destructor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__DESTRUCTOR = 25;

	/**
	 * The feature id for the '<em><b>Double Semi Colon</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__DOUBLE_SEMI_COLON = 26;

	/**
	 * The feature id for the '<em><b>Driveletters</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__DRIVELETTERS = 27;

	/**
	 * The feature id for the '<em><b>Eikbuttons</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__EIKBUTTONS = 28;

	/**
	 * The feature id for the '<em><b>Eikonenvstatic</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__EIKONENVSTATIC = 29;

	/**
	 * The feature id for the '<em><b>Enummembers</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__ENUMMEMBERS = 30;

	/**
	 * The feature id for the '<em><b>Enumnames</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__ENUMNAMES = 31;

	/**
	 * The feature id for the '<em><b>Exportinline</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__EXPORTINLINE = 32;

	/**
	 * The feature id for the '<em><b>Exportpurevirtual</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__EXPORTPUREVIRTUAL = 33;

	/**
	 * The feature id for the '<em><b>Externaldriveletters</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__EXTERNALDRIVELETTERS = 34;

	/**
	 * The feature id for the '<em><b>Flags</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__FLAGS = 35;

	/**
	 * The feature id for the '<em><b>Foff</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__FOFF = 36;

	/**
	 * The feature id for the '<em><b>Forbiddenwords</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__FORBIDDENWORDS = 37;

	/**
	 * The feature id for the '<em><b>Forgottoputptroncleanupstack</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__FORGOTTOPUTPTRONCLEANUPSTACK = 38;

	/**
	 * The feature id for the '<em><b>Friend</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__FRIEND = 39;

	/**
	 * The feature id for the '<em><b>Goto</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__GOTO = 40;

	/**
	 * The feature id for the '<em><b>Ifassignments</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__IFASSIGNMENTS = 41;

	/**
	 * The feature id for the '<em><b>Ifpreprocessor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__IFPREPROCESSOR = 42;

	/**
	 * The feature id for the '<em><b>Inheritanceorder</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__INHERITANCEORDER = 43;

	/**
	 * The feature id for the '<em><b>Intleaves</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__INTLEAVES = 44;

	/**
	 * The feature id for the '<em><b>Jmp</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__JMP = 45;

	/**
	 * The feature id for the '<em><b>Leave</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__LEAVE = 46;

	/**
	 * The feature id for the '<em><b>Leave No Error</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__LEAVE_NO_ERROR = 47;

	/**
	 * The feature id for the '<em><b>Leavingoperators</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__LEAVINGOPERATORS = 48;

	/**
	 * The feature id for the '<em><b>LFunction Cant Leave</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__LFUNCTION_CANT_LEAVE = 49;

	/**
	 * The feature id for the '<em><b>Longlines</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__LONGLINES = 50;

	/**
	 * The feature id for the '<em><b>Magicnumbers</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__MAGICNUMBERS = 51;

	/**
	 * The feature id for the '<em><b>Mclassdestructor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__MCLASSDESTRUCTOR = 52;

	/**
	 * The feature id for the '<em><b>Memberlc</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__MEMBERLC = 53;

	/**
	 * The feature id for the '<em><b>Membervariablecallld</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__MEMBERVARIABLECALLLD = 54;

	/**
	 * The feature id for the '<em><b>Missingcancel</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__MISSINGCANCEL = 55;

	/**
	 * The feature id for the '<em><b>Missingcclass</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__MISSINGCCLASS = 56;

	/**
	 * The feature id for the '<em><b>Mmpsourcepath</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__MMPSOURCEPATH = 57;

	/**
	 * The feature id for the '<em><b>Multilangrsc</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__MULTILANGRSC = 58;

	/**
	 * The feature id for the '<em><b>Multipledeclarations</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__MULTIPLEDECLARATIONS = 59;

	/**
	 * The feature id for the '<em><b>Multipleinheritance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__MULTIPLEINHERITANCE = 60;

	/**
	 * The feature id for the '<em><b>Mydocs</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__MYDOCS = 61;

	/**
	 * The feature id for the '<em><b>Namespace</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__NAMESPACE = 62;

	/**
	 * The feature id for the '<em><b>Newlreferences</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__NEWLREFERENCES = 63;

	/**
	 * The feature id for the '<em><b>Noleavetrap</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__NOLEAVETRAP = 64;

	/**
	 * The feature id for the '<em><b>Nonconsthbufc</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__NONCONSTHBUFC = 65;

	/**
	 * The feature id for the '<em><b>Nonconsttdesc</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__NONCONSTTDESC = 66;

	/**
	 * The feature id for the '<em><b>Nonleavenew</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__NONLEAVENEW = 67;

	/**
	 * The feature id for the '<em><b>Nonunicodeskins</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__NONUNICODESKINS = 68;

	/**
	 * The feature id for the '<em><b>Null</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__NULL = 69;

	/**
	 * The feature id for the '<em><b>Open</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__OPEN = 70;

	/**
	 * The feature id for the '<em><b>Pointertoarrays</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__POINTERTOARRAYS = 71;

	/**
	 * The feature id for the '<em><b>Pragmadisable</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__PRAGMADISABLE = 72;

	/**
	 * The feature id for the '<em><b>Pragmamessage</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__PRAGMAMESSAGE = 73;

	/**
	 * The feature id for the '<em><b>Pragmaother</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__PRAGMAOTHER = 74;

	/**
	 * The feature id for the '<em><b>Privateinheritance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__PRIVATEINHERITANCE = 75;

	/**
	 * The feature id for the '<em><b>Pushaddrvar</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__PUSHADDRVAR = 76;

	/**
	 * The feature id for the '<em><b>Pushmember</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__PUSHMEMBER = 77;

	/**
	 * The feature id for the '<em><b>Readresource</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__READRESOURCE = 78;

	/**
	 * The feature id for the '<em><b>Resourcenotoncleanupstack</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__RESOURCENOTONCLEANUPSTACK = 79;

	/**
	 * The feature id for the '<em><b>Resourcesonheap</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__RESOURCESONHEAP = 80;

	/**
	 * The feature id for the '<em><b>Returndescriptoroutofscope</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__RETURNDESCRIPTOROUTOFSCOPE = 81;

	/**
	 * The feature id for the '<em><b>Rfs</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__RFS = 82;

	/**
	 * The feature id for the '<em><b>Rssnames</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__RSSNAMES = 83;

	/**
	 * The feature id for the '<em><b>Stringliterals</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__STRINGLITERALS = 84;

	/**
	 * The feature id for the '<em><b>Stringsinresourcefiles</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__STRINGSINRESOURCEFILES = 85;

	/**
	 * The feature id for the '<em><b>Struct</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__STRUCT = 86;

	/**
	 * The feature id for the '<em><b>Tcclasses</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__TCCLASSES = 87;

	/**
	 * The feature id for the '<em><b>Tclassdestructor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__TCLASSDESTRUCTOR = 88;

	/**
	 * The feature id for the '<em><b>Todocomments</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__TODOCOMMENTS = 89;

	/**
	 * The feature id for the '<em><b>Trapcleanup</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__TRAPCLEANUP = 90;

	/**
	 * The feature id for the '<em><b>Trapeleave</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__TRAPELEAVE = 91;

	/**
	 * The feature id for the '<em><b>Traprunl</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__TRAPRUNL = 92;

	/**
	 * The feature id for the '<em><b>Trspassing</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__TRSPASSING = 93;

	/**
	 * The feature id for the '<em><b>Uids</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__UIDS = 94;

	/**
	 * The feature id for the '<em><b>Uncompressedaif</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__UNCOMPRESSEDAIF = 95;

	/**
	 * The feature id for the '<em><b>Uncompressedbmp</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__UNCOMPRESSEDBMP = 96;

	/**
	 * The feature id for the '<em><b>Unicodesource</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__UNICODESOURCE = 97;

	/**
	 * The feature id for the '<em><b>Userafter</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__USERAFTER = 98;

	/**
	 * The feature id for the '<em><b>Userfree</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__USERFREE = 99;

	/**
	 * The feature id for the '<em><b>User Wait For Request</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__USER_WAIT_FOR_REQUEST = 100;

	/**
	 * The feature id for the '<em><b>Variablenames</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__VARIABLENAMES = 101;

	/**
	 * The feature id for the '<em><b>Voidparameter</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__VOIDPARAMETER = 102;

	/**
	 * The feature id for the '<em><b>Worryingcomments</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE__WORRYINGCOMMENTS = 103;

	/**
	 * The number of structural features of the '<em>Scripts Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCRIPTS_TYPE_FEATURE_COUNT = 104;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.SeveritiesTypeImpl <em>Severities Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.SeveritiesTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getSeveritiesType()
	 * @generated
	 */
	int SEVERITIES_TYPE = 104;

	/**
	 * The feature id for the '<em><b>High</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEVERITIES_TYPE__HIGH = 0;

	/**
	 * The feature id for the '<em><b>Medium</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEVERITIES_TYPE__MEDIUM = 1;

	/**
	 * The feature id for the '<em><b>Low</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEVERITIES_TYPE__LOW = 2;

	/**
	 * The number of structural features of the '<em>Severities Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEVERITIES_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.SourcesTypeImpl <em>Sources Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.SourcesTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getSourcesType()
	 * @generated
	 */
	int SOURCES_TYPE = 105;

	/**
	 * The feature id for the '<em><b>Exclude</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOURCES_TYPE__EXCLUDE = 0;

	/**
	 * The number of structural features of the '<em>Sources Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOURCES_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.StringliteralsTypeImpl <em>Stringliterals Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.StringliteralsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getStringliteralsType()
	 * @generated
	 */
	int STRINGLITERALS_TYPE = 106;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRINGLITERALS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRINGLITERALS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRINGLITERALS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Stringliterals Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRINGLITERALS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.StringsinresourcefilesTypeImpl <em>Stringsinresourcefiles Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.StringsinresourcefilesTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getStringsinresourcefilesType()
	 * @generated
	 */
	int STRINGSINRESOURCEFILES_TYPE = 107;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRINGSINRESOURCEFILES_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRINGSINRESOURCEFILES_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRINGSINRESOURCEFILES_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Stringsinresourcefiles Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRINGSINRESOURCEFILES_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.StructTypeImpl <em>Struct Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.StructTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getStructType()
	 * @generated
	 */
	int STRUCT_TYPE = 108;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCT_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCT_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCT_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Struct Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCT_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.TcclassesTypeImpl <em>Tcclasses Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.TcclassesTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getTcclassesType()
	 * @generated
	 */
	int TCCLASSES_TYPE = 109;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TCCLASSES_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TCCLASSES_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TCCLASSES_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Tcclasses Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TCCLASSES_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.TclassdestructorTypeImpl <em>Tclassdestructor Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.TclassdestructorTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getTclassdestructorType()
	 * @generated
	 */
	int TCLASSDESTRUCTOR_TYPE = 110;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TCLASSDESTRUCTOR_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TCLASSDESTRUCTOR_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TCLASSDESTRUCTOR_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Tclassdestructor Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TCLASSDESTRUCTOR_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.TodocommentsTypeImpl <em>Todocomments Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.TodocommentsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getTodocommentsType()
	 * @generated
	 */
	int TODOCOMMENTS_TYPE = 111;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TODOCOMMENTS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TODOCOMMENTS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TODOCOMMENTS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Todocomments Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TODOCOMMENTS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.TrapcleanupTypeImpl <em>Trapcleanup Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.TrapcleanupTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getTrapcleanupType()
	 * @generated
	 */
	int TRAPCLEANUP_TYPE = 112;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAPCLEANUP_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAPCLEANUP_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAPCLEANUP_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Trapcleanup Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAPCLEANUP_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.TrapeleaveTypeImpl <em>Trapeleave Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.TrapeleaveTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getTrapeleaveType()
	 * @generated
	 */
	int TRAPELEAVE_TYPE = 113;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAPELEAVE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAPELEAVE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAPELEAVE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Trapeleave Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAPELEAVE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.TraprunlTypeImpl <em>Traprunl Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.TraprunlTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getTraprunlType()
	 * @generated
	 */
	int TRAPRUNL_TYPE = 114;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAPRUNL_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAPRUNL_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAPRUNL_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Traprunl Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAPRUNL_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.TrspassingTypeImpl <em>Trspassing Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.TrspassingTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getTrspassingType()
	 * @generated
	 */
	int TRSPASSING_TYPE = 115;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRSPASSING_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRSPASSING_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRSPASSING_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Trspassing Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRSPASSING_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.UidsTypeImpl <em>Uids Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.UidsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getUidsType()
	 * @generated
	 */
	int UIDS_TYPE = 116;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UIDS_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UIDS_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UIDS_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Uids Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UIDS_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.UncompressedaifTypeImpl <em>Uncompressedaif Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.UncompressedaifTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getUncompressedaifType()
	 * @generated
	 */
	int UNCOMPRESSEDAIF_TYPE = 117;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNCOMPRESSEDAIF_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNCOMPRESSEDAIF_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNCOMPRESSEDAIF_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Uncompressedaif Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNCOMPRESSEDAIF_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.UncompressedbmpTypeImpl <em>Uncompressedbmp Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.UncompressedbmpTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getUncompressedbmpType()
	 * @generated
	 */
	int UNCOMPRESSEDBMP_TYPE = 118;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNCOMPRESSEDBMP_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNCOMPRESSEDBMP_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNCOMPRESSEDBMP_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Uncompressedbmp Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNCOMPRESSEDBMP_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.UnicodesourceTypeImpl <em>Unicodesource Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.UnicodesourceTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getUnicodesourceType()
	 * @generated
	 */
	int UNICODESOURCE_TYPE = 119;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNICODESOURCE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNICODESOURCE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNICODESOURCE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Unicodesource Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNICODESOURCE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.UserafterTypeImpl <em>Userafter Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.UserafterTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getUserafterType()
	 * @generated
	 */
	int USERAFTER_TYPE = 120;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USERAFTER_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USERAFTER_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USERAFTER_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Userafter Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USERAFTER_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.UserfreeTypeImpl <em>Userfree Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.UserfreeTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getUserfreeType()
	 * @generated
	 */
	int USERFREE_TYPE = 121;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USERFREE_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USERFREE_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USERFREE_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Userfree Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USERFREE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.UserWaitForRequestTypeImpl <em>User Wait For Request Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.UserWaitForRequestTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getUserWaitForRequestType()
	 * @generated
	 */
	int USER_WAIT_FOR_REQUEST_TYPE = 122;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_WAIT_FOR_REQUEST_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_WAIT_FOR_REQUEST_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_WAIT_FOR_REQUEST_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>User Wait For Request Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_WAIT_FOR_REQUEST_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.VariablenamesTypeImpl <em>Variablenames Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.VariablenamesTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getVariablenamesType()
	 * @generated
	 */
	int VARIABLENAMES_TYPE = 123;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLENAMES_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLENAMES_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLENAMES_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Variablenames Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLENAMES_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.VoidparameterTypeImpl <em>Voidparameter Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.VoidparameterTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getVoidparameterType()
	 * @generated
	 */
	int VOIDPARAMETER_TYPE = 124;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOIDPARAMETER_TYPE__CATEGORY = 0;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOIDPARAMETER_TYPE__ENABLE = 1;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOIDPARAMETER_TYPE__SEVERITY = 2;

	/**
	 * The number of structural features of the '<em>Voidparameter Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOIDPARAMETER_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.WorryingcommentsTypeImpl <em>Worryingcomments Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.WorryingcommentsTypeImpl
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getWorryingcommentsType()
	 * @generated
	 */
	int WORRYINGCOMMENTS_TYPE = 125;

	/**
	 * The feature id for the '<em><b>Worry RE</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORRYINGCOMMENTS_TYPE__WORRY_RE = 0;

	/**
	 * The feature id for the '<em><b>Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORRYINGCOMMENTS_TYPE__CATEGORY = 1;

	/**
	 * The feature id for the '<em><b>Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORRYINGCOMMENTS_TYPE__ENABLE = 2;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORRYINGCOMMENTS_TYPE__SEVERITY = 3;

	/**
	 * The number of structural features of the '<em>Worryingcomments Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORRYINGCOMMENTS_TYPE_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoryType <em>Category Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoryType
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getCategoryType()
	 * @generated
	 */
	int CATEGORY_TYPE = 126;

	/**
	 * The meta object id for the '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeverityType <em>Severity Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeverityType
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getSeverityType()
	 * @generated
	 */
	int SEVERITY_TYPE = 127;

	/**
	 * The meta object id for the '<em>Category Type Object</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoryType
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getCategoryTypeObject()
	 * @generated
	 */
	int CATEGORY_TYPE_OBJECT = 128;

	/**
	 * The meta object id for the '<em>Severity Type Object</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeverityType
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.impl.CSConfigPackageImpl#getSeverityTypeObject()
	 * @generated
	 */
	int SEVERITY_TYPE_OBJECT = 129;


	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheck2Type <em>Access Array Element Without Check2 Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Access Array Element Without Check2 Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheck2Type
	 * @generated
	 */
	EClass getAccessArrayElementWithoutCheck2Type();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheck2Type#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheck2Type#getCategory()
	 * @see #getAccessArrayElementWithoutCheck2Type()
	 * @generated
	 */
	EAttribute getAccessArrayElementWithoutCheck2Type_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheck2Type#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheck2Type#isEnable()
	 * @see #getAccessArrayElementWithoutCheck2Type()
	 * @generated
	 */
	EAttribute getAccessArrayElementWithoutCheck2Type_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheck2Type#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheck2Type#getSeverity()
	 * @see #getAccessArrayElementWithoutCheck2Type()
	 * @generated
	 */
	EAttribute getAccessArrayElementWithoutCheck2Type_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheckType <em>Access Array Element Without Check Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Access Array Element Without Check Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheckType
	 * @generated
	 */
	EClass getAccessArrayElementWithoutCheckType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheckType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheckType#getCategory()
	 * @see #getAccessArrayElementWithoutCheckType()
	 * @generated
	 */
	EAttribute getAccessArrayElementWithoutCheckType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheckType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheckType#isEnable()
	 * @see #getAccessArrayElementWithoutCheckType()
	 * @generated
	 */
	EAttribute getAccessArrayElementWithoutCheckType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheckType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AccessArrayElementWithoutCheckType#getSeverity()
	 * @see #getAccessArrayElementWithoutCheckType()
	 * @generated
	 */
	EAttribute getAccessArrayElementWithoutCheckType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestartType <em>Activestart Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Activestart Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestartType
	 * @generated
	 */
	EClass getActivestartType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestartType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestartType#getCategory()
	 * @see #getActivestartType()
	 * @generated
	 */
	EAttribute getActivestartType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestartType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestartType#isEnable()
	 * @see #getActivestartType()
	 * @generated
	 */
	EAttribute getActivestartType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestartType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestartType#getSeverity()
	 * @see #getActivestartType()
	 * @generated
	 */
	EAttribute getActivestartType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestopType <em>Activestop Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Activestop Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestopType
	 * @generated
	 */
	EClass getActivestopType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestopType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestopType#getCategory()
	 * @see #getActivestopType()
	 * @generated
	 */
	EAttribute getActivestopType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestopType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestopType#isEnable()
	 * @see #getActivestopType()
	 * @generated
	 */
	EAttribute getActivestopType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestopType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ActivestopType#getSeverity()
	 * @see #getActivestopType()
	 * @generated
	 */
	EAttribute getActivestopType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArgumentsType <em>Arguments Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Arguments Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArgumentsType
	 * @generated
	 */
	EClass getArgumentsType();

	/**
	 * Returns the meta object for the attribute list '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArgumentsType#getInput <em>Input</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Input</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArgumentsType#getInput()
	 * @see #getArgumentsType()
	 * @generated
	 */
	EAttribute getArgumentsType_Input();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArgumentsType#getLxr <em>Lxr</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Lxr</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArgumentsType#getLxr()
	 * @see #getArgumentsType()
	 * @generated
	 */
	EAttribute getArgumentsType_Lxr();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArgumentsType#getLxrversion <em>Lxrversion</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Lxrversion</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArgumentsType#getLxrversion()
	 * @see #getArgumentsType()
	 * @generated
	 */
	EAttribute getArgumentsType_Lxrversion();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArgumentsType#getOutputformat <em>Outputformat</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Outputformat</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArgumentsType#getOutputformat()
	 * @see #getArgumentsType()
	 * @generated
	 */
	EAttribute getArgumentsType_Outputformat();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArgumentsType#getTimestampedoutput <em>Timestampedoutput</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Timestampedoutput</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArgumentsType#getTimestampedoutput()
	 * @see #getArgumentsType()
	 * @generated
	 */
	EAttribute getArgumentsType_Timestampedoutput();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArraypassingType <em>Arraypassing Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Arraypassing Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArraypassingType
	 * @generated
	 */
	EClass getArraypassingType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArraypassingType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArraypassingType#getCategory()
	 * @see #getArraypassingType()
	 * @generated
	 */
	EAttribute getArraypassingType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArraypassingType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArraypassingType#isEnable()
	 * @see #getArraypassingType()
	 * @generated
	 */
	EAttribute getArraypassingType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArraypassingType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArraypassingType#getSeverity()
	 * @see #getArraypassingType()
	 * @generated
	 */
	EAttribute getArraypassingType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArrayptrcleanupType <em>Arrayptrcleanup Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Arrayptrcleanup Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArrayptrcleanupType
	 * @generated
	 */
	EClass getArrayptrcleanupType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArrayptrcleanupType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArrayptrcleanupType#getCategory()
	 * @see #getArrayptrcleanupType()
	 * @generated
	 */
	EAttribute getArrayptrcleanupType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArrayptrcleanupType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArrayptrcleanupType#isEnable()
	 * @see #getArrayptrcleanupType()
	 * @generated
	 */
	EAttribute getArrayptrcleanupType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArrayptrcleanupType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ArrayptrcleanupType#getSeverity()
	 * @see #getArrayptrcleanupType()
	 * @generated
	 */
	EAttribute getArrayptrcleanupType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AssertdebuginvariantType <em>Assertdebuginvariant Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Assertdebuginvariant Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AssertdebuginvariantType
	 * @generated
	 */
	EClass getAssertdebuginvariantType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AssertdebuginvariantType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AssertdebuginvariantType#getCategory()
	 * @see #getAssertdebuginvariantType()
	 * @generated
	 */
	EAttribute getAssertdebuginvariantType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AssertdebuginvariantType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AssertdebuginvariantType#isEnable()
	 * @see #getAssertdebuginvariantType()
	 * @generated
	 */
	EAttribute getAssertdebuginvariantType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AssertdebuginvariantType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.AssertdebuginvariantType#getSeverity()
	 * @see #getAssertdebuginvariantType()
	 * @generated
	 */
	EAttribute getAssertdebuginvariantType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaddefinesType <em>Baddefines Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Baddefines Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaddefinesType
	 * @generated
	 */
	EClass getBaddefinesType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaddefinesType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaddefinesType#getCategory()
	 * @see #getBaddefinesType()
	 * @generated
	 */
	EAttribute getBaddefinesType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaddefinesType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaddefinesType#isEnable()
	 * @see #getBaddefinesType()
	 * @generated
	 */
	EAttribute getBaddefinesType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaddefinesType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaddefinesType#getSeverity()
	 * @see #getBaddefinesType()
	 * @generated
	 */
	EAttribute getBaddefinesType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaseconstructType <em>Baseconstruct Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Baseconstruct Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaseconstructType
	 * @generated
	 */
	EClass getBaseconstructType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaseconstructType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaseconstructType#getCategory()
	 * @see #getBaseconstructType()
	 * @generated
	 */
	EAttribute getBaseconstructType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaseconstructType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaseconstructType#isEnable()
	 * @see #getBaseconstructType()
	 * @generated
	 */
	EAttribute getBaseconstructType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaseconstructType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.BaseconstructType#getSeverity()
	 * @see #getBaseconstructType()
	 * @generated
	 */
	EAttribute getBaseconstructType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CallActiveObjectWithoutCheckingOrStoppingType <em>Call Active Object Without Checking Or Stopping Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call Active Object Without Checking Or Stopping Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CallActiveObjectWithoutCheckingOrStoppingType
	 * @generated
	 */
	EClass getCallActiveObjectWithoutCheckingOrStoppingType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CallActiveObjectWithoutCheckingOrStoppingType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CallActiveObjectWithoutCheckingOrStoppingType#getCategory()
	 * @see #getCallActiveObjectWithoutCheckingOrStoppingType()
	 * @generated
	 */
	EAttribute getCallActiveObjectWithoutCheckingOrStoppingType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CallActiveObjectWithoutCheckingOrStoppingType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CallActiveObjectWithoutCheckingOrStoppingType#isEnable()
	 * @see #getCallActiveObjectWithoutCheckingOrStoppingType()
	 * @generated
	 */
	EAttribute getCallActiveObjectWithoutCheckingOrStoppingType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CallActiveObjectWithoutCheckingOrStoppingType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CallActiveObjectWithoutCheckingOrStoppingType#getSeverity()
	 * @see #getCallActiveObjectWithoutCheckingOrStoppingType()
	 * @generated
	 */
	EAttribute getCallActiveObjectWithoutCheckingOrStoppingType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CanpanicType <em>Canpanic Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Canpanic Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CanpanicType
	 * @generated
	 */
	EClass getCanpanicType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CanpanicType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CanpanicType#isEnable()
	 * @see #getCanpanicType()
	 * @generated
	 */
	EAttribute getCanpanicType_Enable();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType <em>Categories Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Categories Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType
	 * @generated
	 */
	EClass getCategoriesType();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getCanpanic <em>Canpanic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Canpanic</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getCanpanic()
	 * @see #getCategoriesType()
	 * @generated
	 */
	EReference getCategoriesType_Canpanic();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getCodereview <em>Codereview</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Codereview</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getCodereview()
	 * @see #getCategoriesType()
	 * @generated
	 */
	EReference getCategoriesType_Codereview();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getCodingstandards <em>Codingstandards</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Codingstandards</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getCodingstandards()
	 * @see #getCategoriesType()
	 * @generated
	 */
	EReference getCategoriesType_Codingstandards();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getDocumentation <em>Documentation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Documentation</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getDocumentation()
	 * @see #getCategoriesType()
	 * @generated
	 */
	EReference getCategoriesType_Documentation();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getFunctionality <em>Functionality</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Functionality</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getFunctionality()
	 * @see #getCategoriesType()
	 * @generated
	 */
	EReference getCategoriesType_Functionality();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getLegal <em>Legal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Legal</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getLegal()
	 * @see #getCategoriesType()
	 * @generated
	 */
	EReference getCategoriesType_Legal();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getLocalisation <em>Localisation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Localisation</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getLocalisation()
	 * @see #getCategoriesType()
	 * @generated
	 */
	EReference getCategoriesType_Localisation();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getOther <em>Other</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Other</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getOther()
	 * @see #getCategoriesType()
	 * @generated
	 */
	EReference getCategoriesType_Other();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getPanic <em>Panic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Panic</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getPanic()
	 * @see #getCategoriesType()
	 * @generated
	 */
	EReference getCategoriesType_Panic();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getPerformance <em>Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Performance</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoriesType#getPerformance()
	 * @see #getCategoriesType()
	 * @generated
	 */
	EReference getCategoriesType_Performance();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ChangenotificationType <em>Changenotification Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Changenotification Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ChangenotificationType
	 * @generated
	 */
	EClass getChangenotificationType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ChangenotificationType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ChangenotificationType#getCategory()
	 * @see #getChangenotificationType()
	 * @generated
	 */
	EAttribute getChangenotificationType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ChangenotificationType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ChangenotificationType#isEnable()
	 * @see #getChangenotificationType()
	 * @generated
	 */
	EAttribute getChangenotificationType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ChangenotificationType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ChangenotificationType#getSeverity()
	 * @see #getChangenotificationType()
	 * @generated
	 */
	EAttribute getChangenotificationType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CleanupType <em>Cleanup Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cleanup Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CleanupType
	 * @generated
	 */
	EClass getCleanupType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CleanupType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CleanupType#getCategory()
	 * @see #getCleanupType()
	 * @generated
	 */
	EAttribute getCleanupType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CleanupType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CleanupType#isEnable()
	 * @see #getCleanupType()
	 * @generated
	 */
	EAttribute getCleanupType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CleanupType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CleanupType#getSeverity()
	 * @see #getCleanupType()
	 * @generated
	 */
	EAttribute getCleanupType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodereviewType <em>Codereview Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Codereview Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodereviewType
	 * @generated
	 */
	EClass getCodereviewType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodereviewType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodereviewType#isEnable()
	 * @see #getCodereviewType()
	 * @generated
	 */
	EAttribute getCodereviewType_Enable();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodescannerConfigType <em>Codescanner Config Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Codescanner Config Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodescannerConfigType
	 * @generated
	 */
	EClass getCodescannerConfigType();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodescannerConfigType#getArguments <em>Arguments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Arguments</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodescannerConfigType#getArguments()
	 * @see #getCodescannerConfigType()
	 * @generated
	 */
	EReference getCodescannerConfigType_Arguments();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodescannerConfigType#getCustomrules <em>Customrules</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Customrules</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodescannerConfigType#getCustomrules()
	 * @see #getCodescannerConfigType()
	 * @generated
	 */
	EReference getCodescannerConfigType_Customrules();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodescannerConfigType#getSources <em>Sources</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Sources</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodescannerConfigType#getSources()
	 * @see #getCodescannerConfigType()
	 * @generated
	 */
	EReference getCodescannerConfigType_Sources();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodescannerConfigType#getScripts <em>Scripts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Scripts</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodescannerConfigType#getScripts()
	 * @see #getCodescannerConfigType()
	 * @generated
	 */
	EReference getCodescannerConfigType_Scripts();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodescannerConfigType#getSeverities <em>Severities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Severities</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodescannerConfigType#getSeverities()
	 * @see #getCodescannerConfigType()
	 * @generated
	 */
	EReference getCodescannerConfigType_Severities();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodescannerConfigType#getCategories <em>Categories</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Categories</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodescannerConfigType#getCategories()
	 * @see #getCodescannerConfigType()
	 * @generated
	 */
	EReference getCodescannerConfigType_Categories();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodingstandardsType <em>Codingstandards Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Codingstandards Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodingstandardsType
	 * @generated
	 */
	EClass getCodingstandardsType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodingstandardsType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CodingstandardsType#isEnable()
	 * @see #getCodingstandardsType()
	 * @generated
	 */
	EAttribute getCodingstandardsType_Enable();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CommentcodeType <em>Commentcode Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Commentcode Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CommentcodeType
	 * @generated
	 */
	EClass getCommentcodeType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CommentcodeType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CommentcodeType#getCategory()
	 * @see #getCommentcodeType()
	 * @generated
	 */
	EAttribute getCommentcodeType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CommentcodeType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CommentcodeType#isEnable()
	 * @see #getCommentcodeType()
	 * @generated
	 */
	EAttribute getCommentcodeType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CommentcodeType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CommentcodeType#getSeverity()
	 * @see #getCommentcodeType()
	 * @generated
	 */
	EAttribute getCommentcodeType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectAndDontCloseMemberVariableType <em>Connect And Dont Close Member Variable Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Connect And Dont Close Member Variable Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectAndDontCloseMemberVariableType
	 * @generated
	 */
	EClass getConnectAndDontCloseMemberVariableType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectAndDontCloseMemberVariableType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectAndDontCloseMemberVariableType#getCategory()
	 * @see #getConnectAndDontCloseMemberVariableType()
	 * @generated
	 */
	EAttribute getConnectAndDontCloseMemberVariableType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectAndDontCloseMemberVariableType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectAndDontCloseMemberVariableType#isEnable()
	 * @see #getConnectAndDontCloseMemberVariableType()
	 * @generated
	 */
	EAttribute getConnectAndDontCloseMemberVariableType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectAndDontCloseMemberVariableType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectAndDontCloseMemberVariableType#getSeverity()
	 * @see #getConnectAndDontCloseMemberVariableType()
	 * @generated
	 */
	EAttribute getConnectAndDontCloseMemberVariableType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectType <em>Connect Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Connect Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectType
	 * @generated
	 */
	EClass getConnectType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectType#getCategory()
	 * @see #getConnectType()
	 * @generated
	 */
	EAttribute getConnectType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectType#isEnable()
	 * @see #getConnectType()
	 * @generated
	 */
	EAttribute getConnectType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConnectType#getSeverity()
	 * @see #getConnectType()
	 * @generated
	 */
	EAttribute getConnectType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConstnamesType <em>Constnames Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constnames Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConstnamesType
	 * @generated
	 */
	EClass getConstnamesType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConstnamesType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConstnamesType#getCategory()
	 * @see #getConstnamesType()
	 * @generated
	 */
	EAttribute getConstnamesType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConstnamesType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConstnamesType#isEnable()
	 * @see #getConstnamesType()
	 * @generated
	 */
	EAttribute getConstnamesType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConstnamesType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConstnamesType#getSeverity()
	 * @see #getConstnamesType()
	 * @generated
	 */
	EAttribute getConstnamesType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConsttdescptrType <em>Consttdescptr Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Consttdescptr Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConsttdescptrType
	 * @generated
	 */
	EClass getConsttdescptrType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConsttdescptrType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConsttdescptrType#getCategory()
	 * @see #getConsttdescptrType()
	 * @generated
	 */
	EAttribute getConsttdescptrType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConsttdescptrType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConsttdescptrType#isEnable()
	 * @see #getConsttdescptrType()
	 * @generated
	 */
	EAttribute getConsttdescptrType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConsttdescptrType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ConsttdescptrType#getSeverity()
	 * @see #getConsttdescptrType()
	 * @generated
	 */
	EAttribute getConsttdescptrType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ControlornullType <em>Controlornull Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Controlornull Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ControlornullType
	 * @generated
	 */
	EClass getControlornullType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ControlornullType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ControlornullType#getCategory()
	 * @see #getControlornullType()
	 * @generated
	 */
	EAttribute getControlornullType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ControlornullType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ControlornullType#isEnable()
	 * @see #getControlornullType()
	 * @generated
	 */
	EAttribute getControlornullType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ControlornullType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ControlornullType#getSeverity()
	 * @see #getControlornullType()
	 * @generated
	 */
	EAttribute getControlornullType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CrepositoryType <em>Crepository Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Crepository Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CrepositoryType
	 * @generated
	 */
	EClass getCrepositoryType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CrepositoryType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CrepositoryType#getCategory()
	 * @see #getCrepositoryType()
	 * @generated
	 */
	EAttribute getCrepositoryType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CrepositoryType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CrepositoryType#isEnable()
	 * @see #getCrepositoryType()
	 * @generated
	 */
	EAttribute getCrepositoryType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CrepositoryType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CrepositoryType#getSeverity()
	 * @see #getCrepositoryType()
	 * @generated
	 */
	EAttribute getCrepositoryType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CtltargettypeType <em>Ctltargettype Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Ctltargettype Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CtltargettypeType
	 * @generated
	 */
	EClass getCtltargettypeType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CtltargettypeType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CtltargettypeType#getCategory()
	 * @see #getCtltargettypeType()
	 * @generated
	 */
	EAttribute getCtltargettypeType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CtltargettypeType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CtltargettypeType#isEnable()
	 * @see #getCtltargettypeType()
	 * @generated
	 */
	EAttribute getCtltargettypeType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CtltargettypeType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CtltargettypeType#getSeverity()
	 * @see #getCtltargettypeType()
	 * @generated
	 */
	EAttribute getCtltargettypeType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomizableiconsType <em>Customizableicons Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Customizableicons Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomizableiconsType
	 * @generated
	 */
	EClass getCustomizableiconsType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomizableiconsType#getIconsRE <em>Icons RE</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Icons RE</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomizableiconsType#getIconsRE()
	 * @see #getCustomizableiconsType()
	 * @generated
	 */
	EAttribute getCustomizableiconsType_IconsRE();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomizableiconsType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomizableiconsType#getCategory()
	 * @see #getCustomizableiconsType()
	 * @generated
	 */
	EAttribute getCustomizableiconsType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomizableiconsType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomizableiconsType#isEnable()
	 * @see #getCustomizableiconsType()
	 * @generated
	 */
	EAttribute getCustomizableiconsType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomizableiconsType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomizableiconsType#getSeverity()
	 * @see #getCustomizableiconsType()
	 * @generated
	 */
	EAttribute getCustomizableiconsType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomrulesType <em>Customrules Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Customrules Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomrulesType
	 * @generated
	 */
	EClass getCustomrulesType();

	/**
	 * Returns the meta object for the containment reference list '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomrulesType#getCustomrule <em>Customrule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Customrule</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomrulesType#getCustomrule()
	 * @see #getCustomrulesType()
	 * @generated
	 */
	EReference getCustomrulesType_Customrule();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType <em>Customrule Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Customrule Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType
	 * @generated
	 */
	EClass getCustomruleType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType#getName()
	 * @see #getCustomruleType()
	 * @generated
	 */
	EAttribute getCustomruleType_Name();

	/**
	 * Returns the meta object for the containment reference list '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType#getKeyword <em>Keyword</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Keyword</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType#getKeyword()
	 * @see #getCustomruleType()
	 * @generated
	 */
	EReference getCustomruleType_Keyword();

	/**
	 * Returns the meta object for the attribute list '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType#getFiletype <em>Filetype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Filetype</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType#getFiletype()
	 * @see #getCustomruleType()
	 * @generated
	 */
	EAttribute getCustomruleType_Filetype();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType#getSeverity()
	 * @see #getCustomruleType()
	 * @generated
	 */
	EAttribute getCustomruleType_Severity();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType#getTitle <em>Title</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Title</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType#getTitle()
	 * @see #getCustomruleType()
	 * @generated
	 */
	EAttribute getCustomruleType_Title();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType#getDescription()
	 * @see #getCustomruleType()
	 * @generated
	 */
	EAttribute getCustomruleType_Description();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType#getLink <em>Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Link</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CustomruleType#getLink()
	 * @see #getCustomruleType()
	 * @generated
	 */
	EAttribute getCustomruleType_Link();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DebugromType <em>Debugrom Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Debugrom Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DebugromType
	 * @generated
	 */
	EClass getDebugromType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DebugromType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DebugromType#getCategory()
	 * @see #getDebugromType()
	 * @generated
	 */
	EAttribute getDebugromType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DebugromType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DebugromType#isEnable()
	 * @see #getDebugromType()
	 * @generated
	 */
	EAttribute getDebugromType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DebugromType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DebugromType#getSeverity()
	 * @see #getDebugromType()
	 * @generated
	 */
	EAttribute getDebugromType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeclarenameType <em>Declarename Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Declarename Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeclarenameType
	 * @generated
	 */
	EClass getDeclarenameType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeclarenameType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeclarenameType#getCategory()
	 * @see #getDeclarenameType()
	 * @generated
	 */
	EAttribute getDeclarenameType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeclarenameType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeclarenameType#isEnable()
	 * @see #getDeclarenameType()
	 * @generated
	 */
	EAttribute getDeclarenameType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeclarenameType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeclarenameType#getSeverity()
	 * @see #getDeclarenameType()
	 * @generated
	 */
	EAttribute getDeclarenameType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeleteMemberVariableType <em>Delete Member Variable Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Delete Member Variable Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeleteMemberVariableType
	 * @generated
	 */
	EClass getDeleteMemberVariableType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeleteMemberVariableType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeleteMemberVariableType#getCategory()
	 * @see #getDeleteMemberVariableType()
	 * @generated
	 */
	EAttribute getDeleteMemberVariableType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeleteMemberVariableType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeleteMemberVariableType#isEnable()
	 * @see #getDeleteMemberVariableType()
	 * @generated
	 */
	EAttribute getDeleteMemberVariableType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeleteMemberVariableType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DeleteMemberVariableType#getSeverity()
	 * @see #getDeleteMemberVariableType()
	 * @generated
	 */
	EAttribute getDeleteMemberVariableType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DestructorType <em>Destructor Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Destructor Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DestructorType
	 * @generated
	 */
	EClass getDestructorType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DestructorType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DestructorType#getCategory()
	 * @see #getDestructorType()
	 * @generated
	 */
	EAttribute getDestructorType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DestructorType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DestructorType#isEnable()
	 * @see #getDestructorType()
	 * @generated
	 */
	EAttribute getDestructorType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DestructorType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DestructorType#getSeverity()
	 * @see #getDestructorType()
	 * @generated
	 */
	EAttribute getDestructorType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentationType <em>Documentation Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Documentation Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentationType
	 * @generated
	 */
	EClass getDocumentationType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentationType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentationType#isEnable()
	 * @see #getDocumentationType()
	 * @generated
	 */
	EAttribute getDocumentationType_Enable();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot <em>Document Root</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Document Root</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot
	 * @generated
	 */
	EClass getDocumentRoot();

	/**
	 * Returns the meta object for the attribute list '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMixed <em>Mixed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Mixed</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMixed()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Mixed();

	/**
	 * Returns the meta object for the map '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getXMLNSPrefixMap <em>XMLNS Prefix Map</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the map '<em>XMLNS Prefix Map</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getXMLNSPrefixMap()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_XMLNSPrefixMap();

	/**
	 * Returns the meta object for the map '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getXSISchemaLocation <em>XSI Schema Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the map '<em>XSI Schema Location</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getXSISchemaLocation()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_XSISchemaLocation();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getAccessArrayElementWithoutCheck <em>Access Array Element Without Check</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Access Array Element Without Check</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getAccessArrayElementWithoutCheck()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_AccessArrayElementWithoutCheck();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getAccessArrayElementWithoutCheck2 <em>Access Array Element Without Check2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Access Array Element Without Check2</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getAccessArrayElementWithoutCheck2()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_AccessArrayElementWithoutCheck2();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getActivestart <em>Activestart</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Activestart</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getActivestart()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Activestart();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getActivestop <em>Activestop</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Activestop</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getActivestop()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Activestop();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getArguments <em>Arguments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Arguments</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getArguments()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Arguments();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getArraypassing <em>Arraypassing</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Arraypassing</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getArraypassing()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Arraypassing();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getArrayptrcleanup <em>Arrayptrcleanup</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Arrayptrcleanup</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getArrayptrcleanup()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Arrayptrcleanup();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getAssertdebuginvariant <em>Assertdebuginvariant</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Assertdebuginvariant</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getAssertdebuginvariant()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Assertdebuginvariant();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getBaddefines <em>Baddefines</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Baddefines</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getBaddefines()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Baddefines();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getBaseconstruct <em>Baseconstruct</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Baseconstruct</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getBaseconstruct()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Baseconstruct();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCallActiveObjectWithoutCheckingOrStopping <em>Call Active Object Without Checking Or Stopping</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Call Active Object Without Checking Or Stopping</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCallActiveObjectWithoutCheckingOrStopping()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_CallActiveObjectWithoutCheckingOrStopping();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCanpanic <em>Canpanic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Canpanic</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCanpanic()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Canpanic();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCategories <em>Categories</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Categories</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCategories()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Categories();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCclassIgnoreRE <em>Cclass Ignore RE</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Cclass Ignore RE</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCclassIgnoreRE()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_CclassIgnoreRE();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getChangenotification <em>Changenotification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Changenotification</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getChangenotification()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Changenotification();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCleanup <em>Cleanup</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Cleanup</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCleanup()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Cleanup();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCodereview <em>Codereview</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Codereview</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCodereview()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Codereview();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCodescannerConfig <em>Codescanner Config</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Codescanner Config</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCodescannerConfig()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_CodescannerConfig();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCodingstandards <em>Codingstandards</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Codingstandards</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCodingstandards()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Codingstandards();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCommentcode <em>Commentcode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Commentcode</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCommentcode()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Commentcode();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getConnect <em>Connect</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Connect</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getConnect()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Connect();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getConnectAndDontCloseMemberVariable <em>Connect And Dont Close Member Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Connect And Dont Close Member Variable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getConnectAndDontCloseMemberVariable()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_ConnectAndDontCloseMemberVariable();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getConstnames <em>Constnames</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Constnames</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getConstnames()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Constnames();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getConsttdescptr <em>Consttdescptr</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Consttdescptr</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getConsttdescptr()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Consttdescptr();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getControlornull <em>Controlornull</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Controlornull</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getControlornull()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Controlornull();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCrepository <em>Crepository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Crepository</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCrepository()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Crepository();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCtltargettype <em>Ctltargettype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Ctltargettype</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCtltargettype()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Ctltargettype();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCustomizableicons <em>Customizableicons</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Customizableicons</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCustomizableicons()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Customizableicons();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCustomrule <em>Customrule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Customrule</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCustomrule()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Customrule();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCustomrules <em>Customrules</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Customrules</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCustomrules()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Customrules();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDebugrom <em>Debugrom</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Debugrom</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDebugrom()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Debugrom();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDeclarename <em>Declarename</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Declarename</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDeclarename()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Declarename();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDeleteMemberVariable <em>Delete Member Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Delete Member Variable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDeleteMemberVariable()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_DeleteMemberVariable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDescription()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Description();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDestructor <em>Destructor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Destructor</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDestructor()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Destructor();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDocumentation <em>Documentation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Documentation</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDocumentation()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Documentation();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDoubleSemiColon <em>Double Semi Colon</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Double Semi Colon</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDoubleSemiColon()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_DoubleSemiColon();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDriveletters <em>Driveletters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Driveletters</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getDriveletters()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Driveletters();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getEikbuttons <em>Eikbuttons</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Eikbuttons</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getEikbuttons()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Eikbuttons();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getEikonenvstatic <em>Eikonenvstatic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Eikonenvstatic</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getEikonenvstatic()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Eikonenvstatic();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getEnummembers <em>Enummembers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Enummembers</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getEnummembers()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Enummembers();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getEnumnames <em>Enumnames</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Enumnames</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getEnumnames()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Enumnames();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getExclude <em>Exclude</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Exclude</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getExclude()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Exclude();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getExportinline <em>Exportinline</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Exportinline</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getExportinline()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Exportinline();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getExportpurevirtual <em>Exportpurevirtual</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Exportpurevirtual</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getExportpurevirtual()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Exportpurevirtual();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getExternaldriveletters <em>Externaldriveletters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Externaldriveletters</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getExternaldriveletters()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Externaldriveletters();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getFiletype <em>Filetype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Filetype</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getFiletype()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Filetype();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getFlags <em>Flags</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Flags</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getFlags()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Flags();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getFoff <em>Foff</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Foff</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getFoff()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Foff();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getForbiddenwords <em>Forbiddenwords</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Forbiddenwords</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getForbiddenwords()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Forbiddenwords();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getForgottoputptroncleanupstack <em>Forgottoputptroncleanupstack</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Forgottoputptroncleanupstack</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getForgottoputptroncleanupstack()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Forgottoputptroncleanupstack();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getFriend <em>Friend</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Friend</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getFriend()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Friend();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getFunctionality <em>Functionality</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Functionality</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getFunctionality()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Functionality();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getGoto <em>Goto</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Goto</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getGoto()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Goto();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getHigh <em>High</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>High</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getHigh()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_High();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getIconsRE <em>Icons RE</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Icons RE</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getIconsRE()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_IconsRE();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getIfassignments <em>Ifassignments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Ifassignments</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getIfassignments()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Ifassignments();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getIfpreprocessor <em>Ifpreprocessor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Ifpreprocessor</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getIfpreprocessor()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Ifpreprocessor();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getInheritanceorder <em>Inheritanceorder</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Inheritanceorder</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getInheritanceorder()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Inheritanceorder();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getInput <em>Input</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Input</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getInput()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Input();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getIntleaves <em>Intleaves</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Intleaves</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getIntleaves()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Intleaves();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getJmp <em>Jmp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Jmp</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getJmp()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Jmp();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getKeyword <em>Keyword</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Keyword</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getKeyword()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Keyword();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLeave <em>Leave</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Leave</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLeave()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Leave();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLeaveNoError <em>Leave No Error</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Leave No Error</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLeaveNoError()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_LeaveNoError();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLeavingoperators <em>Leavingoperators</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Leavingoperators</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLeavingoperators()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Leavingoperators();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLegal <em>Legal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Legal</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLegal()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Legal();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLFunctionCantLeave <em>LFunction Cant Leave</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>LFunction Cant Leave</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLFunctionCantLeave()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_LFunctionCantLeave();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLFunctionIgnoreRE <em>LFunction Ignore RE</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>LFunction Ignore RE</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLFunctionIgnoreRE()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_LFunctionIgnoreRE();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLink <em>Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Link</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLink()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Link();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLocalisation <em>Localisation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Localisation</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLocalisation()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Localisation();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLonglines <em>Longlines</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Longlines</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLonglines()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Longlines();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLow <em>Low</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Low</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLow()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Low();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLxr <em>Lxr</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Lxr</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLxr()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Lxr();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLxrversion <em>Lxrversion</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Lxrversion</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getLxrversion()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Lxrversion();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMagicnumbers <em>Magicnumbers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Magicnumbers</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMagicnumbers()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Magicnumbers();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMclassdestructor <em>Mclassdestructor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Mclassdestructor</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMclassdestructor()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Mclassdestructor();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMedium <em>Medium</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Medium</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMedium()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Medium();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMemberlc <em>Memberlc</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Memberlc</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMemberlc()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Memberlc();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMembervariablecallld <em>Membervariablecallld</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Membervariablecallld</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMembervariablecallld()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Membervariablecallld();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMissingcancel <em>Missingcancel</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Missingcancel</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMissingcancel()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Missingcancel();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMissingcclass <em>Missingcclass</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Missingcclass</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMissingcclass()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Missingcclass();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMmpsourcepath <em>Mmpsourcepath</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Mmpsourcepath</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMmpsourcepath()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Mmpsourcepath();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMultilangrsc <em>Multilangrsc</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Multilangrsc</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMultilangrsc()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Multilangrsc();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMultipledeclarations <em>Multipledeclarations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Multipledeclarations</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMultipledeclarations()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Multipledeclarations();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMultipleinheritance <em>Multipleinheritance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Multipleinheritance</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMultipleinheritance()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Multipleinheritance();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMydocs <em>Mydocs</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Mydocs</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getMydocs()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Mydocs();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getName()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Name();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNamespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Namespace</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNamespace()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Namespace();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNewlreferences <em>Newlreferences</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Newlreferences</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNewlreferences()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Newlreferences();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNoleavetrap <em>Noleavetrap</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Noleavetrap</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNoleavetrap()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Noleavetrap();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNonconsthbufc <em>Nonconsthbufc</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Nonconsthbufc</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNonconsthbufc()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Nonconsthbufc();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNonconsttdesc <em>Nonconsttdesc</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Nonconsttdesc</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNonconsttdesc()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Nonconsttdesc();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNonleavenew <em>Nonleavenew</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Nonleavenew</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNonleavenew()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Nonleavenew();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNonunicodeskins <em>Nonunicodeskins</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Nonunicodeskins</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNonunicodeskins()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Nonunicodeskins();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNull <em>Null</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Null</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getNull()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Null();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getOpen <em>Open</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Open</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getOpen()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Open();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getOpenIgnoreRE <em>Open Ignore RE</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Open Ignore RE</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getOpenIgnoreRE()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_OpenIgnoreRE();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getOther <em>Other</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Other</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getOther()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Other();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getOutputformat <em>Outputformat</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Outputformat</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getOutputformat()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Outputformat();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPanic <em>Panic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Panic</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPanic()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Panic();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPerformance <em>Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Performance</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPerformance()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Performance();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPointertoarrays <em>Pointertoarrays</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pointertoarrays</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPointertoarrays()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Pointertoarrays();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPragmadisable <em>Pragmadisable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pragmadisable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPragmadisable()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Pragmadisable();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPragmamessage <em>Pragmamessage</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pragmamessage</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPragmamessage()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Pragmamessage();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPragmaother <em>Pragmaother</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pragmaother</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPragmaother()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Pragmaother();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPrivateinheritance <em>Privateinheritance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Privateinheritance</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPrivateinheritance()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Privateinheritance();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPushaddrvar <em>Pushaddrvar</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pushaddrvar</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPushaddrvar()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Pushaddrvar();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPushmember <em>Pushmember</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pushmember</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getPushmember()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Pushmember();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getReadresource <em>Readresource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Readresource</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getReadresource()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Readresource();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getResourcenotoncleanupstack <em>Resourcenotoncleanupstack</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Resourcenotoncleanupstack</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getResourcenotoncleanupstack()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Resourcenotoncleanupstack();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getResourcesonheap <em>Resourcesonheap</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Resourcesonheap</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getResourcesonheap()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Resourcesonheap();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getReturndescriptoroutofscope <em>Returndescriptoroutofscope</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Returndescriptoroutofscope</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getReturndescriptoroutofscope()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Returndescriptoroutofscope();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getRfs <em>Rfs</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Rfs</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getRfs()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Rfs();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getRssnames <em>Rssnames</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Rssnames</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getRssnames()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Rssnames();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getScripts <em>Scripts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Scripts</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getScripts()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Scripts();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getSeverities <em>Severities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Severities</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getSeverities()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Severities();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getSources <em>Sources</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Sources</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getSources()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Sources();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getStringliterals <em>Stringliterals</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Stringliterals</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getStringliterals()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Stringliterals();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getStringsinresourcefiles <em>Stringsinresourcefiles</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Stringsinresourcefiles</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getStringsinresourcefiles()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Stringsinresourcefiles();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getStruct <em>Struct</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Struct</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getStruct()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Struct();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTcclasses <em>Tcclasses</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Tcclasses</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTcclasses()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Tcclasses();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTclassdestructor <em>Tclassdestructor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Tclassdestructor</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTclassdestructor()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Tclassdestructor();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTimestampedoutput <em>Timestampedoutput</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Timestampedoutput</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTimestampedoutput()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Timestampedoutput();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTitle <em>Title</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Title</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTitle()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Title();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTodocomments <em>Todocomments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Todocomments</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTodocomments()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Todocomments();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTrapcleanup <em>Trapcleanup</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Trapcleanup</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTrapcleanup()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Trapcleanup();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTrapeleave <em>Trapeleave</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Trapeleave</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTrapeleave()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Trapeleave();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTraprunl <em>Traprunl</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Traprunl</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTraprunl()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Traprunl();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTrspassing <em>Trspassing</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Trspassing</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getTrspassing()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Trspassing();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getUids <em>Uids</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Uids</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getUids()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Uids();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getUncompressedaif <em>Uncompressedaif</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Uncompressedaif</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getUncompressedaif()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Uncompressedaif();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getUncompressedbmp <em>Uncompressedbmp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Uncompressedbmp</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getUncompressedbmp()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Uncompressedbmp();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getUnicodesource <em>Unicodesource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Unicodesource</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getUnicodesource()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Unicodesource();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getUserafter <em>Userafter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Userafter</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getUserafter()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Userafter();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getUserfree <em>Userfree</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Userfree</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getUserfree()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Userfree();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getUserWaitForRequest <em>User Wait For Request</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>User Wait For Request</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getUserWaitForRequest()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_UserWaitForRequest();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getVariablenames <em>Variablenames</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Variablenames</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getVariablenames()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Variablenames();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getVoidparameter <em>Voidparameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Voidparameter</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getVoidparameter()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Voidparameter();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getWordsRE <em>Words RE</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Words RE</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getWordsRE()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_WordsRE();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getWorryingcomments <em>Worryingcomments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Worryingcomments</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getWorryingcomments()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Worryingcomments();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getWorryRE <em>Worry RE</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Worry RE</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getWorryRE()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_WorryRE();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getCategory()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getSeverity1 <em>Severity1</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity1</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getSeverity1()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Severity1();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DocumentRoot#getSeverity()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DoubleSemiColonType <em>Double Semi Colon Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Double Semi Colon Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DoubleSemiColonType
	 * @generated
	 */
	EClass getDoubleSemiColonType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DoubleSemiColonType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DoubleSemiColonType#getCategory()
	 * @see #getDoubleSemiColonType()
	 * @generated
	 */
	EAttribute getDoubleSemiColonType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DoubleSemiColonType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DoubleSemiColonType#isEnable()
	 * @see #getDoubleSemiColonType()
	 * @generated
	 */
	EAttribute getDoubleSemiColonType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DoubleSemiColonType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DoubleSemiColonType#getSeverity()
	 * @see #getDoubleSemiColonType()
	 * @generated
	 */
	EAttribute getDoubleSemiColonType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DrivelettersType <em>Driveletters Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Driveletters Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DrivelettersType
	 * @generated
	 */
	EClass getDrivelettersType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DrivelettersType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DrivelettersType#getCategory()
	 * @see #getDrivelettersType()
	 * @generated
	 */
	EAttribute getDrivelettersType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DrivelettersType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DrivelettersType#isEnable()
	 * @see #getDrivelettersType()
	 * @generated
	 */
	EAttribute getDrivelettersType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DrivelettersType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.DrivelettersType#getSeverity()
	 * @see #getDrivelettersType()
	 * @generated
	 */
	EAttribute getDrivelettersType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikbuttonsType <em>Eikbuttons Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Eikbuttons Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikbuttonsType
	 * @generated
	 */
	EClass getEikbuttonsType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikbuttonsType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikbuttonsType#getCategory()
	 * @see #getEikbuttonsType()
	 * @generated
	 */
	EAttribute getEikbuttonsType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikbuttonsType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikbuttonsType#isEnable()
	 * @see #getEikbuttonsType()
	 * @generated
	 */
	EAttribute getEikbuttonsType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikbuttonsType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikbuttonsType#getSeverity()
	 * @see #getEikbuttonsType()
	 * @generated
	 */
	EAttribute getEikbuttonsType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikonenvstaticType <em>Eikonenvstatic Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Eikonenvstatic Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikonenvstaticType
	 * @generated
	 */
	EClass getEikonenvstaticType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikonenvstaticType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikonenvstaticType#getCategory()
	 * @see #getEikonenvstaticType()
	 * @generated
	 */
	EAttribute getEikonenvstaticType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikonenvstaticType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikonenvstaticType#isEnable()
	 * @see #getEikonenvstaticType()
	 * @generated
	 */
	EAttribute getEikonenvstaticType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikonenvstaticType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EikonenvstaticType#getSeverity()
	 * @see #getEikonenvstaticType()
	 * @generated
	 */
	EAttribute getEikonenvstaticType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnummembersType <em>Enummembers Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Enummembers Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnummembersType
	 * @generated
	 */
	EClass getEnummembersType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnummembersType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnummembersType#getCategory()
	 * @see #getEnummembersType()
	 * @generated
	 */
	EAttribute getEnummembersType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnummembersType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnummembersType#isEnable()
	 * @see #getEnummembersType()
	 * @generated
	 */
	EAttribute getEnummembersType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnummembersType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnummembersType#getSeverity()
	 * @see #getEnummembersType()
	 * @generated
	 */
	EAttribute getEnummembersType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnumnamesType <em>Enumnames Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Enumnames Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnumnamesType
	 * @generated
	 */
	EClass getEnumnamesType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnumnamesType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnumnamesType#getCategory()
	 * @see #getEnumnamesType()
	 * @generated
	 */
	EAttribute getEnumnamesType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnumnamesType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnumnamesType#isEnable()
	 * @see #getEnumnamesType()
	 * @generated
	 */
	EAttribute getEnumnamesType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnumnamesType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.EnumnamesType#getSeverity()
	 * @see #getEnumnamesType()
	 * @generated
	 */
	EAttribute getEnumnamesType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportinlineType <em>Exportinline Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Exportinline Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportinlineType
	 * @generated
	 */
	EClass getExportinlineType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportinlineType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportinlineType#getCategory()
	 * @see #getExportinlineType()
	 * @generated
	 */
	EAttribute getExportinlineType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportinlineType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportinlineType#isEnable()
	 * @see #getExportinlineType()
	 * @generated
	 */
	EAttribute getExportinlineType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportinlineType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportinlineType#getSeverity()
	 * @see #getExportinlineType()
	 * @generated
	 */
	EAttribute getExportinlineType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportpurevirtualType <em>Exportpurevirtual Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Exportpurevirtual Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportpurevirtualType
	 * @generated
	 */
	EClass getExportpurevirtualType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportpurevirtualType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportpurevirtualType#getCategory()
	 * @see #getExportpurevirtualType()
	 * @generated
	 */
	EAttribute getExportpurevirtualType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportpurevirtualType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportpurevirtualType#isEnable()
	 * @see #getExportpurevirtualType()
	 * @generated
	 */
	EAttribute getExportpurevirtualType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportpurevirtualType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExportpurevirtualType#getSeverity()
	 * @see #getExportpurevirtualType()
	 * @generated
	 */
	EAttribute getExportpurevirtualType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExternaldrivelettersType <em>Externaldriveletters Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Externaldriveletters Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExternaldrivelettersType
	 * @generated
	 */
	EClass getExternaldrivelettersType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExternaldrivelettersType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExternaldrivelettersType#getCategory()
	 * @see #getExternaldrivelettersType()
	 * @generated
	 */
	EAttribute getExternaldrivelettersType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExternaldrivelettersType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExternaldrivelettersType#isEnable()
	 * @see #getExternaldrivelettersType()
	 * @generated
	 */
	EAttribute getExternaldrivelettersType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExternaldrivelettersType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ExternaldrivelettersType#getSeverity()
	 * @see #getExternaldrivelettersType()
	 * @generated
	 */
	EAttribute getExternaldrivelettersType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FlagsType <em>Flags Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flags Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FlagsType
	 * @generated
	 */
	EClass getFlagsType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FlagsType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FlagsType#getCategory()
	 * @see #getFlagsType()
	 * @generated
	 */
	EAttribute getFlagsType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FlagsType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FlagsType#isEnable()
	 * @see #getFlagsType()
	 * @generated
	 */
	EAttribute getFlagsType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FlagsType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FlagsType#getSeverity()
	 * @see #getFlagsType()
	 * @generated
	 */
	EAttribute getFlagsType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FoffType <em>Foff Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Foff Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FoffType
	 * @generated
	 */
	EClass getFoffType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FoffType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FoffType#getCategory()
	 * @see #getFoffType()
	 * @generated
	 */
	EAttribute getFoffType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FoffType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FoffType#isEnable()
	 * @see #getFoffType()
	 * @generated
	 */
	EAttribute getFoffType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FoffType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FoffType#getSeverity()
	 * @see #getFoffType()
	 * @generated
	 */
	EAttribute getFoffType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForbiddenwordsType <em>Forbiddenwords Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Forbiddenwords Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForbiddenwordsType
	 * @generated
	 */
	EClass getForbiddenwordsType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForbiddenwordsType#getWordsRE <em>Words RE</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Words RE</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForbiddenwordsType#getWordsRE()
	 * @see #getForbiddenwordsType()
	 * @generated
	 */
	EAttribute getForbiddenwordsType_WordsRE();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForbiddenwordsType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForbiddenwordsType#getCategory()
	 * @see #getForbiddenwordsType()
	 * @generated
	 */
	EAttribute getForbiddenwordsType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForbiddenwordsType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForbiddenwordsType#isEnable()
	 * @see #getForbiddenwordsType()
	 * @generated
	 */
	EAttribute getForbiddenwordsType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForbiddenwordsType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForbiddenwordsType#getSeverity()
	 * @see #getForbiddenwordsType()
	 * @generated
	 */
	EAttribute getForbiddenwordsType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForgottoputptroncleanupstackType <em>Forgottoputptroncleanupstack Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Forgottoputptroncleanupstack Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForgottoputptroncleanupstackType
	 * @generated
	 */
	EClass getForgottoputptroncleanupstackType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForgottoputptroncleanupstackType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForgottoputptroncleanupstackType#getCategory()
	 * @see #getForgottoputptroncleanupstackType()
	 * @generated
	 */
	EAttribute getForgottoputptroncleanupstackType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForgottoputptroncleanupstackType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForgottoputptroncleanupstackType#isEnable()
	 * @see #getForgottoputptroncleanupstackType()
	 * @generated
	 */
	EAttribute getForgottoputptroncleanupstackType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForgottoputptroncleanupstackType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ForgottoputptroncleanupstackType#getSeverity()
	 * @see #getForgottoputptroncleanupstackType()
	 * @generated
	 */
	EAttribute getForgottoputptroncleanupstackType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FriendType <em>Friend Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Friend Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FriendType
	 * @generated
	 */
	EClass getFriendType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FriendType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FriendType#getCategory()
	 * @see #getFriendType()
	 * @generated
	 */
	EAttribute getFriendType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FriendType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FriendType#isEnable()
	 * @see #getFriendType()
	 * @generated
	 */
	EAttribute getFriendType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FriendType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FriendType#getSeverity()
	 * @see #getFriendType()
	 * @generated
	 */
	EAttribute getFriendType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FunctionalityType <em>Functionality Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Functionality Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FunctionalityType
	 * @generated
	 */
	EClass getFunctionalityType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FunctionalityType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.FunctionalityType#isEnable()
	 * @see #getFunctionalityType()
	 * @generated
	 */
	EAttribute getFunctionalityType_Enable();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.GotoType <em>Goto Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Goto Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.GotoType
	 * @generated
	 */
	EClass getGotoType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.GotoType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.GotoType#getCategory()
	 * @see #getGotoType()
	 * @generated
	 */
	EAttribute getGotoType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.GotoType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.GotoType#isEnable()
	 * @see #getGotoType()
	 * @generated
	 */
	EAttribute getGotoType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.GotoType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.GotoType#getSeverity()
	 * @see #getGotoType()
	 * @generated
	 */
	EAttribute getGotoType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.HighType <em>High Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>High Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.HighType
	 * @generated
	 */
	EClass getHighType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.HighType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.HighType#isEnable()
	 * @see #getHighType()
	 * @generated
	 */
	EAttribute getHighType_Enable();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfassignmentsType <em>Ifassignments Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Ifassignments Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfassignmentsType
	 * @generated
	 */
	EClass getIfassignmentsType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfassignmentsType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfassignmentsType#getCategory()
	 * @see #getIfassignmentsType()
	 * @generated
	 */
	EAttribute getIfassignmentsType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfassignmentsType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfassignmentsType#isEnable()
	 * @see #getIfassignmentsType()
	 * @generated
	 */
	EAttribute getIfassignmentsType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfassignmentsType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfassignmentsType#getSeverity()
	 * @see #getIfassignmentsType()
	 * @generated
	 */
	EAttribute getIfassignmentsType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfpreprocessorType <em>Ifpreprocessor Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Ifpreprocessor Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfpreprocessorType
	 * @generated
	 */
	EClass getIfpreprocessorType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfpreprocessorType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfpreprocessorType#getCategory()
	 * @see #getIfpreprocessorType()
	 * @generated
	 */
	EAttribute getIfpreprocessorType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfpreprocessorType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfpreprocessorType#isEnable()
	 * @see #getIfpreprocessorType()
	 * @generated
	 */
	EAttribute getIfpreprocessorType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfpreprocessorType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IfpreprocessorType#getSeverity()
	 * @see #getIfpreprocessorType()
	 * @generated
	 */
	EAttribute getIfpreprocessorType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.InheritanceorderType <em>Inheritanceorder Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Inheritanceorder Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.InheritanceorderType
	 * @generated
	 */
	EClass getInheritanceorderType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.InheritanceorderType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.InheritanceorderType#getCategory()
	 * @see #getInheritanceorderType()
	 * @generated
	 */
	EAttribute getInheritanceorderType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.InheritanceorderType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.InheritanceorderType#isEnable()
	 * @see #getInheritanceorderType()
	 * @generated
	 */
	EAttribute getInheritanceorderType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.InheritanceorderType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.InheritanceorderType#getSeverity()
	 * @see #getInheritanceorderType()
	 * @generated
	 */
	EAttribute getInheritanceorderType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IntleavesType <em>Intleaves Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Intleaves Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IntleavesType
	 * @generated
	 */
	EClass getIntleavesType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IntleavesType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IntleavesType#getCategory()
	 * @see #getIntleavesType()
	 * @generated
	 */
	EAttribute getIntleavesType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IntleavesType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IntleavesType#isEnable()
	 * @see #getIntleavesType()
	 * @generated
	 */
	EAttribute getIntleavesType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IntleavesType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.IntleavesType#getSeverity()
	 * @see #getIntleavesType()
	 * @generated
	 */
	EAttribute getIntleavesType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.JmpType <em>Jmp Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Jmp Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.JmpType
	 * @generated
	 */
	EClass getJmpType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.JmpType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.JmpType#getCategory()
	 * @see #getJmpType()
	 * @generated
	 */
	EAttribute getJmpType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.JmpType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.JmpType#isEnable()
	 * @see #getJmpType()
	 * @generated
	 */
	EAttribute getJmpType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.JmpType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.JmpType#getSeverity()
	 * @see #getJmpType()
	 * @generated
	 */
	EAttribute getJmpType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.KeywordType <em>Keyword Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Keyword Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.KeywordType
	 * @generated
	 */
	EClass getKeywordType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.KeywordType#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.KeywordType#getValue()
	 * @see #getKeywordType()
	 * @generated
	 */
	EAttribute getKeywordType_Value();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.KeywordType#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.KeywordType#getType()
	 * @see #getKeywordType()
	 * @generated
	 */
	EAttribute getKeywordType_Type();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveNoErrorType <em>Leave No Error Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Leave No Error Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveNoErrorType
	 * @generated
	 */
	EClass getLeaveNoErrorType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveNoErrorType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveNoErrorType#getCategory()
	 * @see #getLeaveNoErrorType()
	 * @generated
	 */
	EAttribute getLeaveNoErrorType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveNoErrorType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveNoErrorType#isEnable()
	 * @see #getLeaveNoErrorType()
	 * @generated
	 */
	EAttribute getLeaveNoErrorType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveNoErrorType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveNoErrorType#getSeverity()
	 * @see #getLeaveNoErrorType()
	 * @generated
	 */
	EAttribute getLeaveNoErrorType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveType <em>Leave Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Leave Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveType
	 * @generated
	 */
	EClass getLeaveType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveType#getCategory()
	 * @see #getLeaveType()
	 * @generated
	 */
	EAttribute getLeaveType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveType#isEnable()
	 * @see #getLeaveType()
	 * @generated
	 */
	EAttribute getLeaveType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeaveType#getSeverity()
	 * @see #getLeaveType()
	 * @generated
	 */
	EAttribute getLeaveType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeavingoperatorsType <em>Leavingoperators Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Leavingoperators Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeavingoperatorsType
	 * @generated
	 */
	EClass getLeavingoperatorsType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeavingoperatorsType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeavingoperatorsType#getCategory()
	 * @see #getLeavingoperatorsType()
	 * @generated
	 */
	EAttribute getLeavingoperatorsType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeavingoperatorsType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeavingoperatorsType#isEnable()
	 * @see #getLeavingoperatorsType()
	 * @generated
	 */
	EAttribute getLeavingoperatorsType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeavingoperatorsType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LeavingoperatorsType#getSeverity()
	 * @see #getLeavingoperatorsType()
	 * @generated
	 */
	EAttribute getLeavingoperatorsType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LegalType <em>Legal Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Legal Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LegalType
	 * @generated
	 */
	EClass getLegalType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LegalType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LegalType#isEnable()
	 * @see #getLegalType()
	 * @generated
	 */
	EAttribute getLegalType_Enable();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LFunctionCantLeaveType <em>LFunction Cant Leave Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>LFunction Cant Leave Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LFunctionCantLeaveType
	 * @generated
	 */
	EClass getLFunctionCantLeaveType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LFunctionCantLeaveType#getLFunctionIgnoreRE <em>LFunction Ignore RE</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>LFunction Ignore RE</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LFunctionCantLeaveType#getLFunctionIgnoreRE()
	 * @see #getLFunctionCantLeaveType()
	 * @generated
	 */
	EAttribute getLFunctionCantLeaveType_LFunctionIgnoreRE();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LFunctionCantLeaveType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LFunctionCantLeaveType#getCategory()
	 * @see #getLFunctionCantLeaveType()
	 * @generated
	 */
	EAttribute getLFunctionCantLeaveType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LFunctionCantLeaveType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LFunctionCantLeaveType#isEnable()
	 * @see #getLFunctionCantLeaveType()
	 * @generated
	 */
	EAttribute getLFunctionCantLeaveType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LFunctionCantLeaveType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LFunctionCantLeaveType#getSeverity()
	 * @see #getLFunctionCantLeaveType()
	 * @generated
	 */
	EAttribute getLFunctionCantLeaveType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LocalisationType <em>Localisation Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Localisation Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LocalisationType
	 * @generated
	 */
	EClass getLocalisationType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LocalisationType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LocalisationType#isEnable()
	 * @see #getLocalisationType()
	 * @generated
	 */
	EAttribute getLocalisationType_Enable();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LonglinesType <em>Longlines Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Longlines Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LonglinesType
	 * @generated
	 */
	EClass getLonglinesType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LonglinesType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LonglinesType#getCategory()
	 * @see #getLonglinesType()
	 * @generated
	 */
	EAttribute getLonglinesType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LonglinesType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LonglinesType#isEnable()
	 * @see #getLonglinesType()
	 * @generated
	 */
	EAttribute getLonglinesType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LonglinesType#getLength <em>Length</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Length</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LonglinesType#getLength()
	 * @see #getLonglinesType()
	 * @generated
	 */
	EAttribute getLonglinesType_Length();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LonglinesType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LonglinesType#getSeverity()
	 * @see #getLonglinesType()
	 * @generated
	 */
	EAttribute getLonglinesType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LowType <em>Low Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Low Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LowType
	 * @generated
	 */
	EClass getLowType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LowType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.LowType#isEnable()
	 * @see #getLowType()
	 * @generated
	 */
	EAttribute getLowType_Enable();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MagicnumbersType <em>Magicnumbers Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Magicnumbers Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MagicnumbersType
	 * @generated
	 */
	EClass getMagicnumbersType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MagicnumbersType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MagicnumbersType#getCategory()
	 * @see #getMagicnumbersType()
	 * @generated
	 */
	EAttribute getMagicnumbersType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MagicnumbersType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MagicnumbersType#isEnable()
	 * @see #getMagicnumbersType()
	 * @generated
	 */
	EAttribute getMagicnumbersType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MagicnumbersType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MagicnumbersType#getSeverity()
	 * @see #getMagicnumbersType()
	 * @generated
	 */
	EAttribute getMagicnumbersType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MclassdestructorType <em>Mclassdestructor Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mclassdestructor Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MclassdestructorType
	 * @generated
	 */
	EClass getMclassdestructorType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MclassdestructorType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MclassdestructorType#getCategory()
	 * @see #getMclassdestructorType()
	 * @generated
	 */
	EAttribute getMclassdestructorType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MclassdestructorType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MclassdestructorType#isEnable()
	 * @see #getMclassdestructorType()
	 * @generated
	 */
	EAttribute getMclassdestructorType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MclassdestructorType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MclassdestructorType#getSeverity()
	 * @see #getMclassdestructorType()
	 * @generated
	 */
	EAttribute getMclassdestructorType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MediumType <em>Medium Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Medium Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MediumType
	 * @generated
	 */
	EClass getMediumType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MediumType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MediumType#isEnable()
	 * @see #getMediumType()
	 * @generated
	 */
	EAttribute getMediumType_Enable();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MemberlcType <em>Memberlc Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Memberlc Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MemberlcType
	 * @generated
	 */
	EClass getMemberlcType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MemberlcType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MemberlcType#getCategory()
	 * @see #getMemberlcType()
	 * @generated
	 */
	EAttribute getMemberlcType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MemberlcType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MemberlcType#isEnable()
	 * @see #getMemberlcType()
	 * @generated
	 */
	EAttribute getMemberlcType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MemberlcType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MemberlcType#getSeverity()
	 * @see #getMemberlcType()
	 * @generated
	 */
	EAttribute getMemberlcType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MembervariablecallldType <em>Membervariablecallld Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Membervariablecallld Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MembervariablecallldType
	 * @generated
	 */
	EClass getMembervariablecallldType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MembervariablecallldType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MembervariablecallldType#getCategory()
	 * @see #getMembervariablecallldType()
	 * @generated
	 */
	EAttribute getMembervariablecallldType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MembervariablecallldType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MembervariablecallldType#isEnable()
	 * @see #getMembervariablecallldType()
	 * @generated
	 */
	EAttribute getMembervariablecallldType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MembervariablecallldType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MembervariablecallldType#getSeverity()
	 * @see #getMembervariablecallldType()
	 * @generated
	 */
	EAttribute getMembervariablecallldType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcancelType <em>Missingcancel Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Missingcancel Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcancelType
	 * @generated
	 */
	EClass getMissingcancelType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcancelType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcancelType#getCategory()
	 * @see #getMissingcancelType()
	 * @generated
	 */
	EAttribute getMissingcancelType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcancelType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcancelType#isEnable()
	 * @see #getMissingcancelType()
	 * @generated
	 */
	EAttribute getMissingcancelType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcancelType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcancelType#getSeverity()
	 * @see #getMissingcancelType()
	 * @generated
	 */
	EAttribute getMissingcancelType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcclassType <em>Missingcclass Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Missingcclass Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcclassType
	 * @generated
	 */
	EClass getMissingcclassType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcclassType#getCclassIgnoreRE <em>Cclass Ignore RE</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Cclass Ignore RE</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcclassType#getCclassIgnoreRE()
	 * @see #getMissingcclassType()
	 * @generated
	 */
	EAttribute getMissingcclassType_CclassIgnoreRE();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcclassType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcclassType#getCategory()
	 * @see #getMissingcclassType()
	 * @generated
	 */
	EAttribute getMissingcclassType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcclassType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcclassType#isEnable()
	 * @see #getMissingcclassType()
	 * @generated
	 */
	EAttribute getMissingcclassType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcclassType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MissingcclassType#getSeverity()
	 * @see #getMissingcclassType()
	 * @generated
	 */
	EAttribute getMissingcclassType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MmpsourcepathType <em>Mmpsourcepath Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mmpsourcepath Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MmpsourcepathType
	 * @generated
	 */
	EClass getMmpsourcepathType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MmpsourcepathType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MmpsourcepathType#getCategory()
	 * @see #getMmpsourcepathType()
	 * @generated
	 */
	EAttribute getMmpsourcepathType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MmpsourcepathType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MmpsourcepathType#isEnable()
	 * @see #getMmpsourcepathType()
	 * @generated
	 */
	EAttribute getMmpsourcepathType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MmpsourcepathType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MmpsourcepathType#getSeverity()
	 * @see #getMmpsourcepathType()
	 * @generated
	 */
	EAttribute getMmpsourcepathType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultilangrscType <em>Multilangrsc Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Multilangrsc Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultilangrscType
	 * @generated
	 */
	EClass getMultilangrscType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultilangrscType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultilangrscType#getCategory()
	 * @see #getMultilangrscType()
	 * @generated
	 */
	EAttribute getMultilangrscType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultilangrscType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultilangrscType#isEnable()
	 * @see #getMultilangrscType()
	 * @generated
	 */
	EAttribute getMultilangrscType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultilangrscType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultilangrscType#getSeverity()
	 * @see #getMultilangrscType()
	 * @generated
	 */
	EAttribute getMultilangrscType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipledeclarationsType <em>Multipledeclarations Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Multipledeclarations Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipledeclarationsType
	 * @generated
	 */
	EClass getMultipledeclarationsType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipledeclarationsType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipledeclarationsType#getCategory()
	 * @see #getMultipledeclarationsType()
	 * @generated
	 */
	EAttribute getMultipledeclarationsType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipledeclarationsType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipledeclarationsType#isEnable()
	 * @see #getMultipledeclarationsType()
	 * @generated
	 */
	EAttribute getMultipledeclarationsType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipledeclarationsType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipledeclarationsType#getSeverity()
	 * @see #getMultipledeclarationsType()
	 * @generated
	 */
	EAttribute getMultipledeclarationsType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipleinheritanceType <em>Multipleinheritance Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Multipleinheritance Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipleinheritanceType
	 * @generated
	 */
	EClass getMultipleinheritanceType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipleinheritanceType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipleinheritanceType#getCategory()
	 * @see #getMultipleinheritanceType()
	 * @generated
	 */
	EAttribute getMultipleinheritanceType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipleinheritanceType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipleinheritanceType#isEnable()
	 * @see #getMultipleinheritanceType()
	 * @generated
	 */
	EAttribute getMultipleinheritanceType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipleinheritanceType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MultipleinheritanceType#getSeverity()
	 * @see #getMultipleinheritanceType()
	 * @generated
	 */
	EAttribute getMultipleinheritanceType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MydocsType <em>Mydocs Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mydocs Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MydocsType
	 * @generated
	 */
	EClass getMydocsType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MydocsType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MydocsType#getCategory()
	 * @see #getMydocsType()
	 * @generated
	 */
	EAttribute getMydocsType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MydocsType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MydocsType#isEnable()
	 * @see #getMydocsType()
	 * @generated
	 */
	EAttribute getMydocsType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MydocsType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.MydocsType#getSeverity()
	 * @see #getMydocsType()
	 * @generated
	 */
	EAttribute getMydocsType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NamespaceType <em>Namespace Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Namespace Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NamespaceType
	 * @generated
	 */
	EClass getNamespaceType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NamespaceType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NamespaceType#getCategory()
	 * @see #getNamespaceType()
	 * @generated
	 */
	EAttribute getNamespaceType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NamespaceType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NamespaceType#isEnable()
	 * @see #getNamespaceType()
	 * @generated
	 */
	EAttribute getNamespaceType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NamespaceType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NamespaceType#getSeverity()
	 * @see #getNamespaceType()
	 * @generated
	 */
	EAttribute getNamespaceType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NewlreferencesType <em>Newlreferences Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Newlreferences Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NewlreferencesType
	 * @generated
	 */
	EClass getNewlreferencesType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NewlreferencesType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NewlreferencesType#getCategory()
	 * @see #getNewlreferencesType()
	 * @generated
	 */
	EAttribute getNewlreferencesType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NewlreferencesType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NewlreferencesType#isEnable()
	 * @see #getNewlreferencesType()
	 * @generated
	 */
	EAttribute getNewlreferencesType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NewlreferencesType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NewlreferencesType#getSeverity()
	 * @see #getNewlreferencesType()
	 * @generated
	 */
	EAttribute getNewlreferencesType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NoleavetrapType <em>Noleavetrap Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Noleavetrap Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NoleavetrapType
	 * @generated
	 */
	EClass getNoleavetrapType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NoleavetrapType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NoleavetrapType#getCategory()
	 * @see #getNoleavetrapType()
	 * @generated
	 */
	EAttribute getNoleavetrapType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NoleavetrapType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NoleavetrapType#isEnable()
	 * @see #getNoleavetrapType()
	 * @generated
	 */
	EAttribute getNoleavetrapType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NoleavetrapType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NoleavetrapType#getSeverity()
	 * @see #getNoleavetrapType()
	 * @generated
	 */
	EAttribute getNoleavetrapType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsthbufcType <em>Nonconsthbufc Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Nonconsthbufc Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsthbufcType
	 * @generated
	 */
	EClass getNonconsthbufcType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsthbufcType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsthbufcType#getCategory()
	 * @see #getNonconsthbufcType()
	 * @generated
	 */
	EAttribute getNonconsthbufcType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsthbufcType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsthbufcType#isEnable()
	 * @see #getNonconsthbufcType()
	 * @generated
	 */
	EAttribute getNonconsthbufcType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsthbufcType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsthbufcType#getSeverity()
	 * @see #getNonconsthbufcType()
	 * @generated
	 */
	EAttribute getNonconsthbufcType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsttdescType <em>Nonconsttdesc Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Nonconsttdesc Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsttdescType
	 * @generated
	 */
	EClass getNonconsttdescType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsttdescType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsttdescType#getCategory()
	 * @see #getNonconsttdescType()
	 * @generated
	 */
	EAttribute getNonconsttdescType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsttdescType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsttdescType#isEnable()
	 * @see #getNonconsttdescType()
	 * @generated
	 */
	EAttribute getNonconsttdescType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsttdescType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonconsttdescType#getSeverity()
	 * @see #getNonconsttdescType()
	 * @generated
	 */
	EAttribute getNonconsttdescType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonleavenewType <em>Nonleavenew Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Nonleavenew Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonleavenewType
	 * @generated
	 */
	EClass getNonleavenewType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonleavenewType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonleavenewType#getCategory()
	 * @see #getNonleavenewType()
	 * @generated
	 */
	EAttribute getNonleavenewType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonleavenewType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonleavenewType#isEnable()
	 * @see #getNonleavenewType()
	 * @generated
	 */
	EAttribute getNonleavenewType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonleavenewType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonleavenewType#getSeverity()
	 * @see #getNonleavenewType()
	 * @generated
	 */
	EAttribute getNonleavenewType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonunicodeskinsType <em>Nonunicodeskins Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Nonunicodeskins Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonunicodeskinsType
	 * @generated
	 */
	EClass getNonunicodeskinsType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonunicodeskinsType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonunicodeskinsType#getCategory()
	 * @see #getNonunicodeskinsType()
	 * @generated
	 */
	EAttribute getNonunicodeskinsType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonunicodeskinsType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonunicodeskinsType#isEnable()
	 * @see #getNonunicodeskinsType()
	 * @generated
	 */
	EAttribute getNonunicodeskinsType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonunicodeskinsType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NonunicodeskinsType#getSeverity()
	 * @see #getNonunicodeskinsType()
	 * @generated
	 */
	EAttribute getNonunicodeskinsType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NullType <em>Null Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Null Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NullType
	 * @generated
	 */
	EClass getNullType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NullType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NullType#getCategory()
	 * @see #getNullType()
	 * @generated
	 */
	EAttribute getNullType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NullType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NullType#isEnable()
	 * @see #getNullType()
	 * @generated
	 */
	EAttribute getNullType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NullType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.NullType#getSeverity()
	 * @see #getNullType()
	 * @generated
	 */
	EAttribute getNullType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.OpenType <em>Open Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Open Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.OpenType
	 * @generated
	 */
	EClass getOpenType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.OpenType#getOpenIgnoreRE <em>Open Ignore RE</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Open Ignore RE</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.OpenType#getOpenIgnoreRE()
	 * @see #getOpenType()
	 * @generated
	 */
	EAttribute getOpenType_OpenIgnoreRE();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.OpenType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.OpenType#getCategory()
	 * @see #getOpenType()
	 * @generated
	 */
	EAttribute getOpenType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.OpenType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.OpenType#isEnable()
	 * @see #getOpenType()
	 * @generated
	 */
	EAttribute getOpenType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.OpenType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.OpenType#getSeverity()
	 * @see #getOpenType()
	 * @generated
	 */
	EAttribute getOpenType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.OtherType <em>Other Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Other Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.OtherType
	 * @generated
	 */
	EClass getOtherType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.OtherType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.OtherType#isEnable()
	 * @see #getOtherType()
	 * @generated
	 */
	EAttribute getOtherType_Enable();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PanicType <em>Panic Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Panic Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PanicType
	 * @generated
	 */
	EClass getPanicType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PanicType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PanicType#isEnable()
	 * @see #getPanicType()
	 * @generated
	 */
	EAttribute getPanicType_Enable();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PerformanceType <em>Performance Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Performance Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PerformanceType
	 * @generated
	 */
	EClass getPerformanceType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PerformanceType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PerformanceType#isEnable()
	 * @see #getPerformanceType()
	 * @generated
	 */
	EAttribute getPerformanceType_Enable();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PointertoarraysType <em>Pointertoarrays Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pointertoarrays Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PointertoarraysType
	 * @generated
	 */
	EClass getPointertoarraysType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PointertoarraysType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PointertoarraysType#getCategory()
	 * @see #getPointertoarraysType()
	 * @generated
	 */
	EAttribute getPointertoarraysType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PointertoarraysType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PointertoarraysType#isEnable()
	 * @see #getPointertoarraysType()
	 * @generated
	 */
	EAttribute getPointertoarraysType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PointertoarraysType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PointertoarraysType#getSeverity()
	 * @see #getPointertoarraysType()
	 * @generated
	 */
	EAttribute getPointertoarraysType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmadisableType <em>Pragmadisable Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pragmadisable Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmadisableType
	 * @generated
	 */
	EClass getPragmadisableType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmadisableType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmadisableType#getCategory()
	 * @see #getPragmadisableType()
	 * @generated
	 */
	EAttribute getPragmadisableType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmadisableType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmadisableType#isEnable()
	 * @see #getPragmadisableType()
	 * @generated
	 */
	EAttribute getPragmadisableType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmadisableType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmadisableType#getSeverity()
	 * @see #getPragmadisableType()
	 * @generated
	 */
	EAttribute getPragmadisableType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmamessageType <em>Pragmamessage Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pragmamessage Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmamessageType
	 * @generated
	 */
	EClass getPragmamessageType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmamessageType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmamessageType#getCategory()
	 * @see #getPragmamessageType()
	 * @generated
	 */
	EAttribute getPragmamessageType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmamessageType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmamessageType#isEnable()
	 * @see #getPragmamessageType()
	 * @generated
	 */
	EAttribute getPragmamessageType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmamessageType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmamessageType#getSeverity()
	 * @see #getPragmamessageType()
	 * @generated
	 */
	EAttribute getPragmamessageType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmaotherType <em>Pragmaother Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pragmaother Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmaotherType
	 * @generated
	 */
	EClass getPragmaotherType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmaotherType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmaotherType#getCategory()
	 * @see #getPragmaotherType()
	 * @generated
	 */
	EAttribute getPragmaotherType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmaotherType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmaotherType#isEnable()
	 * @see #getPragmaotherType()
	 * @generated
	 */
	EAttribute getPragmaotherType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmaotherType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PragmaotherType#getSeverity()
	 * @see #getPragmaotherType()
	 * @generated
	 */
	EAttribute getPragmaotherType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PrivateinheritanceType <em>Privateinheritance Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Privateinheritance Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PrivateinheritanceType
	 * @generated
	 */
	EClass getPrivateinheritanceType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PrivateinheritanceType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PrivateinheritanceType#getCategory()
	 * @see #getPrivateinheritanceType()
	 * @generated
	 */
	EAttribute getPrivateinheritanceType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PrivateinheritanceType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PrivateinheritanceType#isEnable()
	 * @see #getPrivateinheritanceType()
	 * @generated
	 */
	EAttribute getPrivateinheritanceType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PrivateinheritanceType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PrivateinheritanceType#getSeverity()
	 * @see #getPrivateinheritanceType()
	 * @generated
	 */
	EAttribute getPrivateinheritanceType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushaddrvarType <em>Pushaddrvar Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pushaddrvar Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushaddrvarType
	 * @generated
	 */
	EClass getPushaddrvarType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushaddrvarType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushaddrvarType#getCategory()
	 * @see #getPushaddrvarType()
	 * @generated
	 */
	EAttribute getPushaddrvarType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushaddrvarType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushaddrvarType#isEnable()
	 * @see #getPushaddrvarType()
	 * @generated
	 */
	EAttribute getPushaddrvarType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushaddrvarType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushaddrvarType#getSeverity()
	 * @see #getPushaddrvarType()
	 * @generated
	 */
	EAttribute getPushaddrvarType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushmemberType <em>Pushmember Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pushmember Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushmemberType
	 * @generated
	 */
	EClass getPushmemberType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushmemberType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushmemberType#getCategory()
	 * @see #getPushmemberType()
	 * @generated
	 */
	EAttribute getPushmemberType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushmemberType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushmemberType#isEnable()
	 * @see #getPushmemberType()
	 * @generated
	 */
	EAttribute getPushmemberType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushmemberType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.PushmemberType#getSeverity()
	 * @see #getPushmemberType()
	 * @generated
	 */
	EAttribute getPushmemberType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReadresourceType <em>Readresource Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Readresource Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReadresourceType
	 * @generated
	 */
	EClass getReadresourceType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReadresourceType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReadresourceType#getCategory()
	 * @see #getReadresourceType()
	 * @generated
	 */
	EAttribute getReadresourceType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReadresourceType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReadresourceType#isEnable()
	 * @see #getReadresourceType()
	 * @generated
	 */
	EAttribute getReadresourceType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReadresourceType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReadresourceType#getSeverity()
	 * @see #getReadresourceType()
	 * @generated
	 */
	EAttribute getReadresourceType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcenotoncleanupstackType <em>Resourcenotoncleanupstack Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Resourcenotoncleanupstack Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcenotoncleanupstackType
	 * @generated
	 */
	EClass getResourcenotoncleanupstackType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcenotoncleanupstackType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcenotoncleanupstackType#getCategory()
	 * @see #getResourcenotoncleanupstackType()
	 * @generated
	 */
	EAttribute getResourcenotoncleanupstackType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcenotoncleanupstackType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcenotoncleanupstackType#isEnable()
	 * @see #getResourcenotoncleanupstackType()
	 * @generated
	 */
	EAttribute getResourcenotoncleanupstackType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcenotoncleanupstackType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcenotoncleanupstackType#getSeverity()
	 * @see #getResourcenotoncleanupstackType()
	 * @generated
	 */
	EAttribute getResourcenotoncleanupstackType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcesonheapType <em>Resourcesonheap Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Resourcesonheap Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcesonheapType
	 * @generated
	 */
	EClass getResourcesonheapType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcesonheapType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcesonheapType#getCategory()
	 * @see #getResourcesonheapType()
	 * @generated
	 */
	EAttribute getResourcesonheapType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcesonheapType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcesonheapType#isEnable()
	 * @see #getResourcesonheapType()
	 * @generated
	 */
	EAttribute getResourcesonheapType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcesonheapType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ResourcesonheapType#getSeverity()
	 * @see #getResourcesonheapType()
	 * @generated
	 */
	EAttribute getResourcesonheapType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReturndescriptoroutofscopeType <em>Returndescriptoroutofscope Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Returndescriptoroutofscope Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReturndescriptoroutofscopeType
	 * @generated
	 */
	EClass getReturndescriptoroutofscopeType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReturndescriptoroutofscopeType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReturndescriptoroutofscopeType#getCategory()
	 * @see #getReturndescriptoroutofscopeType()
	 * @generated
	 */
	EAttribute getReturndescriptoroutofscopeType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReturndescriptoroutofscopeType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReturndescriptoroutofscopeType#isEnable()
	 * @see #getReturndescriptoroutofscopeType()
	 * @generated
	 */
	EAttribute getReturndescriptoroutofscopeType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReturndescriptoroutofscopeType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ReturndescriptoroutofscopeType#getSeverity()
	 * @see #getReturndescriptoroutofscopeType()
	 * @generated
	 */
	EAttribute getReturndescriptoroutofscopeType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RfsType <em>Rfs Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rfs Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RfsType
	 * @generated
	 */
	EClass getRfsType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RfsType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RfsType#getCategory()
	 * @see #getRfsType()
	 * @generated
	 */
	EAttribute getRfsType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RfsType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RfsType#isEnable()
	 * @see #getRfsType()
	 * @generated
	 */
	EAttribute getRfsType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RfsType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RfsType#getSeverity()
	 * @see #getRfsType()
	 * @generated
	 */
	EAttribute getRfsType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RssnamesType <em>Rssnames Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rssnames Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RssnamesType
	 * @generated
	 */
	EClass getRssnamesType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RssnamesType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RssnamesType#getCategory()
	 * @see #getRssnamesType()
	 * @generated
	 */
	EAttribute getRssnamesType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RssnamesType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RssnamesType#isEnable()
	 * @see #getRssnamesType()
	 * @generated
	 */
	EAttribute getRssnamesType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RssnamesType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.RssnamesType#getSeverity()
	 * @see #getRssnamesType()
	 * @generated
	 */
	EAttribute getRssnamesType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType <em>Scripts Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Scripts Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType
	 * @generated
	 */
	EClass getScriptsType();

	/**
	 * Returns the meta object for the attribute list '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMixed <em>Mixed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Mixed</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMixed()
	 * @see #getScriptsType()
	 * @generated
	 */
	EAttribute getScriptsType_Mixed();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getAccessArrayElementWithoutCheck <em>Access Array Element Without Check</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Access Array Element Without Check</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getAccessArrayElementWithoutCheck()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_AccessArrayElementWithoutCheck();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getAccessArrayElementWithoutCheck2 <em>Access Array Element Without Check2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Access Array Element Without Check2</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getAccessArrayElementWithoutCheck2()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_AccessArrayElementWithoutCheck2();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getActivestart <em>Activestart</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Activestart</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getActivestart()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Activestart();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getActivestop <em>Activestop</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Activestop</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getActivestop()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Activestop();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getArraypassing <em>Arraypassing</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Arraypassing</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getArraypassing()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Arraypassing();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getArrayptrcleanup <em>Arrayptrcleanup</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Arrayptrcleanup</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getArrayptrcleanup()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Arrayptrcleanup();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getAssertdebuginvariant <em>Assertdebuginvariant</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Assertdebuginvariant</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getAssertdebuginvariant()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Assertdebuginvariant();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getBaddefines <em>Baddefines</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Baddefines</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getBaddefines()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Baddefines();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getBaseconstruct <em>Baseconstruct</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Baseconstruct</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getBaseconstruct()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Baseconstruct();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getCallActiveObjectWithoutCheckingOrStopping <em>Call Active Object Without Checking Or Stopping</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Call Active Object Without Checking Or Stopping</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getCallActiveObjectWithoutCheckingOrStopping()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_CallActiveObjectWithoutCheckingOrStopping();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getChangenotification <em>Changenotification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Changenotification</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getChangenotification()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Changenotification();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getCleanup <em>Cleanup</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Cleanup</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getCleanup()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Cleanup();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getCommentcode <em>Commentcode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Commentcode</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getCommentcode()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Commentcode();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getConnect <em>Connect</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Connect</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getConnect()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Connect();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getConnectAndDontCloseMemberVariable <em>Connect And Dont Close Member Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Connect And Dont Close Member Variable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getConnectAndDontCloseMemberVariable()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_ConnectAndDontCloseMemberVariable();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getConstnames <em>Constnames</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Constnames</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getConstnames()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Constnames();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getConsttdescptr <em>Consttdescptr</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Consttdescptr</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getConsttdescptr()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Consttdescptr();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getControlornull <em>Controlornull</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Controlornull</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getControlornull()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Controlornull();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getCrepository <em>Crepository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Crepository</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getCrepository()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Crepository();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getCtltargettype <em>Ctltargettype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Ctltargettype</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getCtltargettype()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Ctltargettype();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getCustomizableicons <em>Customizableicons</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Customizableicons</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getCustomizableicons()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Customizableicons();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getDebugrom <em>Debugrom</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Debugrom</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getDebugrom()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Debugrom();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getDeclarename <em>Declarename</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Declarename</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getDeclarename()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Declarename();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getDeleteMemberVariable <em>Delete Member Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Delete Member Variable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getDeleteMemberVariable()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_DeleteMemberVariable();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getDestructor <em>Destructor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Destructor</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getDestructor()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Destructor();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getDoubleSemiColon <em>Double Semi Colon</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Double Semi Colon</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getDoubleSemiColon()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_DoubleSemiColon();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getDriveletters <em>Driveletters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Driveletters</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getDriveletters()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Driveletters();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getEikbuttons <em>Eikbuttons</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Eikbuttons</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getEikbuttons()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Eikbuttons();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getEikonenvstatic <em>Eikonenvstatic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Eikonenvstatic</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getEikonenvstatic()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Eikonenvstatic();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getEnummembers <em>Enummembers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Enummembers</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getEnummembers()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Enummembers();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getEnumnames <em>Enumnames</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Enumnames</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getEnumnames()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Enumnames();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getExportinline <em>Exportinline</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Exportinline</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getExportinline()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Exportinline();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getExportpurevirtual <em>Exportpurevirtual</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Exportpurevirtual</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getExportpurevirtual()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Exportpurevirtual();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getExternaldriveletters <em>Externaldriveletters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Externaldriveletters</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getExternaldriveletters()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Externaldriveletters();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getFlags <em>Flags</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Flags</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getFlags()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Flags();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getFoff <em>Foff</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Foff</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getFoff()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Foff();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getForbiddenwords <em>Forbiddenwords</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Forbiddenwords</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getForbiddenwords()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Forbiddenwords();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getForgottoputptroncleanupstack <em>Forgottoputptroncleanupstack</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Forgottoputptroncleanupstack</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getForgottoputptroncleanupstack()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Forgottoputptroncleanupstack();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getFriend <em>Friend</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Friend</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getFriend()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Friend();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getGoto <em>Goto</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Goto</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getGoto()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Goto();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getIfassignments <em>Ifassignments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Ifassignments</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getIfassignments()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Ifassignments();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getIfpreprocessor <em>Ifpreprocessor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Ifpreprocessor</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getIfpreprocessor()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Ifpreprocessor();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getInheritanceorder <em>Inheritanceorder</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Inheritanceorder</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getInheritanceorder()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Inheritanceorder();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getIntleaves <em>Intleaves</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Intleaves</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getIntleaves()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Intleaves();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getJmp <em>Jmp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Jmp</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getJmp()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Jmp();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getLeave <em>Leave</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Leave</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getLeave()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Leave();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getLeaveNoError <em>Leave No Error</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Leave No Error</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getLeaveNoError()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_LeaveNoError();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getLeavingoperators <em>Leavingoperators</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Leavingoperators</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getLeavingoperators()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Leavingoperators();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getLFunctionCantLeave <em>LFunction Cant Leave</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>LFunction Cant Leave</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getLFunctionCantLeave()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_LFunctionCantLeave();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getLonglines <em>Longlines</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Longlines</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getLonglines()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Longlines();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMagicnumbers <em>Magicnumbers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Magicnumbers</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMagicnumbers()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Magicnumbers();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMclassdestructor <em>Mclassdestructor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Mclassdestructor</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMclassdestructor()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Mclassdestructor();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMemberlc <em>Memberlc</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Memberlc</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMemberlc()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Memberlc();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMembervariablecallld <em>Membervariablecallld</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Membervariablecallld</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMembervariablecallld()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Membervariablecallld();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMissingcancel <em>Missingcancel</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Missingcancel</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMissingcancel()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Missingcancel();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMissingcclass <em>Missingcclass</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Missingcclass</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMissingcclass()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Missingcclass();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMmpsourcepath <em>Mmpsourcepath</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Mmpsourcepath</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMmpsourcepath()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Mmpsourcepath();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMultilangrsc <em>Multilangrsc</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Multilangrsc</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMultilangrsc()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Multilangrsc();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMultipledeclarations <em>Multipledeclarations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Multipledeclarations</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMultipledeclarations()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Multipledeclarations();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMultipleinheritance <em>Multipleinheritance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Multipleinheritance</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMultipleinheritance()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Multipleinheritance();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMydocs <em>Mydocs</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Mydocs</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getMydocs()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Mydocs();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNamespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Namespace</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNamespace()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Namespace();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNewlreferences <em>Newlreferences</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Newlreferences</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNewlreferences()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Newlreferences();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNoleavetrap <em>Noleavetrap</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Noleavetrap</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNoleavetrap()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Noleavetrap();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNonconsthbufc <em>Nonconsthbufc</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Nonconsthbufc</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNonconsthbufc()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Nonconsthbufc();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNonconsttdesc <em>Nonconsttdesc</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Nonconsttdesc</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNonconsttdesc()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Nonconsttdesc();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNonleavenew <em>Nonleavenew</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Nonleavenew</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNonleavenew()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Nonleavenew();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNonunicodeskins <em>Nonunicodeskins</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Nonunicodeskins</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNonunicodeskins()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Nonunicodeskins();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNull <em>Null</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Null</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getNull()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Null();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getOpen <em>Open</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Open</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getOpen()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Open();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getPointertoarrays <em>Pointertoarrays</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pointertoarrays</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getPointertoarrays()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Pointertoarrays();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getPragmadisable <em>Pragmadisable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pragmadisable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getPragmadisable()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Pragmadisable();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getPragmamessage <em>Pragmamessage</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pragmamessage</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getPragmamessage()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Pragmamessage();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getPragmaother <em>Pragmaother</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pragmaother</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getPragmaother()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Pragmaother();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getPrivateinheritance <em>Privateinheritance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Privateinheritance</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getPrivateinheritance()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Privateinheritance();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getPushaddrvar <em>Pushaddrvar</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pushaddrvar</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getPushaddrvar()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Pushaddrvar();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getPushmember <em>Pushmember</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pushmember</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getPushmember()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Pushmember();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getReadresource <em>Readresource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Readresource</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getReadresource()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Readresource();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getResourcenotoncleanupstack <em>Resourcenotoncleanupstack</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Resourcenotoncleanupstack</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getResourcenotoncleanupstack()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Resourcenotoncleanupstack();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getResourcesonheap <em>Resourcesonheap</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Resourcesonheap</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getResourcesonheap()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Resourcesonheap();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getReturndescriptoroutofscope <em>Returndescriptoroutofscope</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Returndescriptoroutofscope</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getReturndescriptoroutofscope()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Returndescriptoroutofscope();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getRfs <em>Rfs</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Rfs</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getRfs()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Rfs();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getRssnames <em>Rssnames</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Rssnames</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getRssnames()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Rssnames();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getStringliterals <em>Stringliterals</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Stringliterals</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getStringliterals()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Stringliterals();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getStringsinresourcefiles <em>Stringsinresourcefiles</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Stringsinresourcefiles</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getStringsinresourcefiles()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Stringsinresourcefiles();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getStruct <em>Struct</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Struct</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getStruct()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Struct();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getTcclasses <em>Tcclasses</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Tcclasses</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getTcclasses()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Tcclasses();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getTclassdestructor <em>Tclassdestructor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Tclassdestructor</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getTclassdestructor()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Tclassdestructor();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getTodocomments <em>Todocomments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Todocomments</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getTodocomments()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Todocomments();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getTrapcleanup <em>Trapcleanup</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Trapcleanup</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getTrapcleanup()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Trapcleanup();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getTrapeleave <em>Trapeleave</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Trapeleave</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getTrapeleave()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Trapeleave();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getTraprunl <em>Traprunl</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Traprunl</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getTraprunl()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Traprunl();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getTrspassing <em>Trspassing</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Trspassing</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getTrspassing()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Trspassing();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getUids <em>Uids</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Uids</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getUids()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Uids();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getUncompressedaif <em>Uncompressedaif</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Uncompressedaif</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getUncompressedaif()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Uncompressedaif();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getUncompressedbmp <em>Uncompressedbmp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Uncompressedbmp</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getUncompressedbmp()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Uncompressedbmp();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getUnicodesource <em>Unicodesource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Unicodesource</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getUnicodesource()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Unicodesource();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getUserafter <em>Userafter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Userafter</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getUserafter()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Userafter();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getUserfree <em>Userfree</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Userfree</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getUserfree()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Userfree();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getUserWaitForRequest <em>User Wait For Request</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>User Wait For Request</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getUserWaitForRequest()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_UserWaitForRequest();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getVariablenames <em>Variablenames</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Variablenames</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getVariablenames()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Variablenames();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getVoidparameter <em>Voidparameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Voidparameter</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getVoidparameter()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Voidparameter();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getWorryingcomments <em>Worryingcomments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Worryingcomments</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.ScriptsType#getWorryingcomments()
	 * @see #getScriptsType()
	 * @generated
	 */
	EReference getScriptsType_Worryingcomments();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeveritiesType <em>Severities Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Severities Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeveritiesType
	 * @generated
	 */
	EClass getSeveritiesType();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeveritiesType#getHigh <em>High</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>High</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeveritiesType#getHigh()
	 * @see #getSeveritiesType()
	 * @generated
	 */
	EReference getSeveritiesType_High();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeveritiesType#getMedium <em>Medium</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Medium</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeveritiesType#getMedium()
	 * @see #getSeveritiesType()
	 * @generated
	 */
	EReference getSeveritiesType_Medium();

	/**
	 * Returns the meta object for the containment reference '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeveritiesType#getLow <em>Low</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Low</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeveritiesType#getLow()
	 * @see #getSeveritiesType()
	 * @generated
	 */
	EReference getSeveritiesType_Low();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SourcesType <em>Sources Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sources Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SourcesType
	 * @generated
	 */
	EClass getSourcesType();

	/**
	 * Returns the meta object for the attribute list '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SourcesType#getExclude <em>Exclude</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Exclude</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SourcesType#getExclude()
	 * @see #getSourcesType()
	 * @generated
	 */
	EAttribute getSourcesType_Exclude();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringliteralsType <em>Stringliterals Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Stringliterals Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringliteralsType
	 * @generated
	 */
	EClass getStringliteralsType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringliteralsType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringliteralsType#getCategory()
	 * @see #getStringliteralsType()
	 * @generated
	 */
	EAttribute getStringliteralsType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringliteralsType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringliteralsType#isEnable()
	 * @see #getStringliteralsType()
	 * @generated
	 */
	EAttribute getStringliteralsType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringliteralsType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringliteralsType#getSeverity()
	 * @see #getStringliteralsType()
	 * @generated
	 */
	EAttribute getStringliteralsType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringsinresourcefilesType <em>Stringsinresourcefiles Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Stringsinresourcefiles Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringsinresourcefilesType
	 * @generated
	 */
	EClass getStringsinresourcefilesType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringsinresourcefilesType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringsinresourcefilesType#getCategory()
	 * @see #getStringsinresourcefilesType()
	 * @generated
	 */
	EAttribute getStringsinresourcefilesType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringsinresourcefilesType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringsinresourcefilesType#isEnable()
	 * @see #getStringsinresourcefilesType()
	 * @generated
	 */
	EAttribute getStringsinresourcefilesType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringsinresourcefilesType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StringsinresourcefilesType#getSeverity()
	 * @see #getStringsinresourcefilesType()
	 * @generated
	 */
	EAttribute getStringsinresourcefilesType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StructType <em>Struct Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Struct Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StructType
	 * @generated
	 */
	EClass getStructType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StructType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StructType#getCategory()
	 * @see #getStructType()
	 * @generated
	 */
	EAttribute getStructType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StructType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StructType#isEnable()
	 * @see #getStructType()
	 * @generated
	 */
	EAttribute getStructType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StructType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.StructType#getSeverity()
	 * @see #getStructType()
	 * @generated
	 */
	EAttribute getStructType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TcclassesType <em>Tcclasses Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Tcclasses Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TcclassesType
	 * @generated
	 */
	EClass getTcclassesType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TcclassesType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TcclassesType#getCategory()
	 * @see #getTcclassesType()
	 * @generated
	 */
	EAttribute getTcclassesType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TcclassesType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TcclassesType#isEnable()
	 * @see #getTcclassesType()
	 * @generated
	 */
	EAttribute getTcclassesType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TcclassesType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TcclassesType#getSeverity()
	 * @see #getTcclassesType()
	 * @generated
	 */
	EAttribute getTcclassesType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TclassdestructorType <em>Tclassdestructor Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Tclassdestructor Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TclassdestructorType
	 * @generated
	 */
	EClass getTclassdestructorType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TclassdestructorType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TclassdestructorType#getCategory()
	 * @see #getTclassdestructorType()
	 * @generated
	 */
	EAttribute getTclassdestructorType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TclassdestructorType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TclassdestructorType#isEnable()
	 * @see #getTclassdestructorType()
	 * @generated
	 */
	EAttribute getTclassdestructorType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TclassdestructorType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TclassdestructorType#getSeverity()
	 * @see #getTclassdestructorType()
	 * @generated
	 */
	EAttribute getTclassdestructorType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TodocommentsType <em>Todocomments Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Todocomments Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TodocommentsType
	 * @generated
	 */
	EClass getTodocommentsType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TodocommentsType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TodocommentsType#getCategory()
	 * @see #getTodocommentsType()
	 * @generated
	 */
	EAttribute getTodocommentsType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TodocommentsType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TodocommentsType#isEnable()
	 * @see #getTodocommentsType()
	 * @generated
	 */
	EAttribute getTodocommentsType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TodocommentsType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TodocommentsType#getSeverity()
	 * @see #getTodocommentsType()
	 * @generated
	 */
	EAttribute getTodocommentsType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapcleanupType <em>Trapcleanup Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Trapcleanup Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapcleanupType
	 * @generated
	 */
	EClass getTrapcleanupType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapcleanupType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapcleanupType#getCategory()
	 * @see #getTrapcleanupType()
	 * @generated
	 */
	EAttribute getTrapcleanupType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapcleanupType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapcleanupType#isEnable()
	 * @see #getTrapcleanupType()
	 * @generated
	 */
	EAttribute getTrapcleanupType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapcleanupType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapcleanupType#getSeverity()
	 * @see #getTrapcleanupType()
	 * @generated
	 */
	EAttribute getTrapcleanupType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapeleaveType <em>Trapeleave Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Trapeleave Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapeleaveType
	 * @generated
	 */
	EClass getTrapeleaveType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapeleaveType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapeleaveType#getCategory()
	 * @see #getTrapeleaveType()
	 * @generated
	 */
	EAttribute getTrapeleaveType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapeleaveType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapeleaveType#isEnable()
	 * @see #getTrapeleaveType()
	 * @generated
	 */
	EAttribute getTrapeleaveType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapeleaveType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrapeleaveType#getSeverity()
	 * @see #getTrapeleaveType()
	 * @generated
	 */
	EAttribute getTrapeleaveType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TraprunlType <em>Traprunl Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Traprunl Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TraprunlType
	 * @generated
	 */
	EClass getTraprunlType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TraprunlType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TraprunlType#getCategory()
	 * @see #getTraprunlType()
	 * @generated
	 */
	EAttribute getTraprunlType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TraprunlType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TraprunlType#isEnable()
	 * @see #getTraprunlType()
	 * @generated
	 */
	EAttribute getTraprunlType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TraprunlType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TraprunlType#getSeverity()
	 * @see #getTraprunlType()
	 * @generated
	 */
	EAttribute getTraprunlType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrspassingType <em>Trspassing Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Trspassing Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrspassingType
	 * @generated
	 */
	EClass getTrspassingType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrspassingType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrspassingType#getCategory()
	 * @see #getTrspassingType()
	 * @generated
	 */
	EAttribute getTrspassingType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrspassingType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrspassingType#isEnable()
	 * @see #getTrspassingType()
	 * @generated
	 */
	EAttribute getTrspassingType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrspassingType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.TrspassingType#getSeverity()
	 * @see #getTrspassingType()
	 * @generated
	 */
	EAttribute getTrspassingType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UidsType <em>Uids Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Uids Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UidsType
	 * @generated
	 */
	EClass getUidsType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UidsType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UidsType#getCategory()
	 * @see #getUidsType()
	 * @generated
	 */
	EAttribute getUidsType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UidsType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UidsType#isEnable()
	 * @see #getUidsType()
	 * @generated
	 */
	EAttribute getUidsType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UidsType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UidsType#getSeverity()
	 * @see #getUidsType()
	 * @generated
	 */
	EAttribute getUidsType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedaifType <em>Uncompressedaif Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Uncompressedaif Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedaifType
	 * @generated
	 */
	EClass getUncompressedaifType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedaifType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedaifType#getCategory()
	 * @see #getUncompressedaifType()
	 * @generated
	 */
	EAttribute getUncompressedaifType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedaifType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedaifType#isEnable()
	 * @see #getUncompressedaifType()
	 * @generated
	 */
	EAttribute getUncompressedaifType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedaifType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedaifType#getSeverity()
	 * @see #getUncompressedaifType()
	 * @generated
	 */
	EAttribute getUncompressedaifType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedbmpType <em>Uncompressedbmp Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Uncompressedbmp Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedbmpType
	 * @generated
	 */
	EClass getUncompressedbmpType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedbmpType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedbmpType#getCategory()
	 * @see #getUncompressedbmpType()
	 * @generated
	 */
	EAttribute getUncompressedbmpType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedbmpType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedbmpType#isEnable()
	 * @see #getUncompressedbmpType()
	 * @generated
	 */
	EAttribute getUncompressedbmpType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedbmpType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UncompressedbmpType#getSeverity()
	 * @see #getUncompressedbmpType()
	 * @generated
	 */
	EAttribute getUncompressedbmpType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UnicodesourceType <em>Unicodesource Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unicodesource Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UnicodesourceType
	 * @generated
	 */
	EClass getUnicodesourceType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UnicodesourceType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UnicodesourceType#getCategory()
	 * @see #getUnicodesourceType()
	 * @generated
	 */
	EAttribute getUnicodesourceType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UnicodesourceType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UnicodesourceType#isEnable()
	 * @see #getUnicodesourceType()
	 * @generated
	 */
	EAttribute getUnicodesourceType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UnicodesourceType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UnicodesourceType#getSeverity()
	 * @see #getUnicodesourceType()
	 * @generated
	 */
	EAttribute getUnicodesourceType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserafterType <em>Userafter Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Userafter Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserafterType
	 * @generated
	 */
	EClass getUserafterType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserafterType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserafterType#getCategory()
	 * @see #getUserafterType()
	 * @generated
	 */
	EAttribute getUserafterType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserafterType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserafterType#isEnable()
	 * @see #getUserafterType()
	 * @generated
	 */
	EAttribute getUserafterType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserafterType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserafterType#getSeverity()
	 * @see #getUserafterType()
	 * @generated
	 */
	EAttribute getUserafterType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserfreeType <em>Userfree Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Userfree Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserfreeType
	 * @generated
	 */
	EClass getUserfreeType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserfreeType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserfreeType#getCategory()
	 * @see #getUserfreeType()
	 * @generated
	 */
	EAttribute getUserfreeType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserfreeType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserfreeType#isEnable()
	 * @see #getUserfreeType()
	 * @generated
	 */
	EAttribute getUserfreeType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserfreeType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserfreeType#getSeverity()
	 * @see #getUserfreeType()
	 * @generated
	 */
	EAttribute getUserfreeType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserWaitForRequestType <em>User Wait For Request Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>User Wait For Request Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserWaitForRequestType
	 * @generated
	 */
	EClass getUserWaitForRequestType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserWaitForRequestType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserWaitForRequestType#getCategory()
	 * @see #getUserWaitForRequestType()
	 * @generated
	 */
	EAttribute getUserWaitForRequestType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserWaitForRequestType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserWaitForRequestType#isEnable()
	 * @see #getUserWaitForRequestType()
	 * @generated
	 */
	EAttribute getUserWaitForRequestType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserWaitForRequestType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.UserWaitForRequestType#getSeverity()
	 * @see #getUserWaitForRequestType()
	 * @generated
	 */
	EAttribute getUserWaitForRequestType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VariablenamesType <em>Variablenames Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Variablenames Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VariablenamesType
	 * @generated
	 */
	EClass getVariablenamesType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VariablenamesType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VariablenamesType#getCategory()
	 * @see #getVariablenamesType()
	 * @generated
	 */
	EAttribute getVariablenamesType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VariablenamesType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VariablenamesType#isEnable()
	 * @see #getVariablenamesType()
	 * @generated
	 */
	EAttribute getVariablenamesType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VariablenamesType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VariablenamesType#getSeverity()
	 * @see #getVariablenamesType()
	 * @generated
	 */
	EAttribute getVariablenamesType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VoidparameterType <em>Voidparameter Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Voidparameter Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VoidparameterType
	 * @generated
	 */
	EClass getVoidparameterType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VoidparameterType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VoidparameterType#getCategory()
	 * @see #getVoidparameterType()
	 * @generated
	 */
	EAttribute getVoidparameterType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VoidparameterType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VoidparameterType#isEnable()
	 * @see #getVoidparameterType()
	 * @generated
	 */
	EAttribute getVoidparameterType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VoidparameterType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.VoidparameterType#getSeverity()
	 * @see #getVoidparameterType()
	 * @generated
	 */
	EAttribute getVoidparameterType_Severity();

	/**
	 * Returns the meta object for class '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.WorryingcommentsType <em>Worryingcomments Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Worryingcomments Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.WorryingcommentsType
	 * @generated
	 */
	EClass getWorryingcommentsType();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.WorryingcommentsType#getWorryRE <em>Worry RE</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Worry RE</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.WorryingcommentsType#getWorryRE()
	 * @see #getWorryingcommentsType()
	 * @generated
	 */
	EAttribute getWorryingcommentsType_WorryRE();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.WorryingcommentsType#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.WorryingcommentsType#getCategory()
	 * @see #getWorryingcommentsType()
	 * @generated
	 */
	EAttribute getWorryingcommentsType_Category();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.WorryingcommentsType#isEnable <em>Enable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Enable</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.WorryingcommentsType#isEnable()
	 * @see #getWorryingcommentsType()
	 * @generated
	 */
	EAttribute getWorryingcommentsType_Enable();

	/**
	 * Returns the meta object for the attribute '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.WorryingcommentsType#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.WorryingcommentsType#getSeverity()
	 * @see #getWorryingcommentsType()
	 * @generated
	 */
	EAttribute getWorryingcommentsType_Severity();

	/**
	 * Returns the meta object for enum '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoryType <em>Category Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Category Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoryType
	 * @generated
	 */
	EEnum getCategoryType();

	/**
	 * Returns the meta object for enum '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeverityType <em>Severity Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Severity Type</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeverityType
	 * @generated
	 */
	EEnum getSeverityType();

	/**
	 * Returns the meta object for data type '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoryType <em>Category Type Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Category Type Object</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoryType
	 * @model instanceClass="com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.CategoryType"
	 *        extendedMetaData="name='category_._type:Object' baseType='category_._type'"
	 * @generated
	 */
	EDataType getCategoryTypeObject();

	/**
	 * Returns the meta object for data type '{@link com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeverityType <em>Severity Type Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Severity Type Object</em>'.
	 * @see com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeverityType
	 * @model instanceClass="com.nokia.carbide.cpp.internal.codescanner.gen.CSConfig.SeverityType"
	 *        extendedMetaData="name='severity_._type:Object' baseType='severity_._type'"
	 * @generated
	 */
	EDataType getSeverityTypeObject();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	CSConfigFactory getCSConfigFactory();

} //CSConfigPackage
